require('../../style/less/telecom.less');

var appFunc = require('../utils/appFunc'),
		Swipe = require('../utils/swipe'),
    template = require('./call.tpl.html');

var callView = {
    init: function(){
				callView.memberID = Phone2Phone.getCookie("memberID");
        callView.bindEvents();
    },
    render: function(){
        if($$('#callView .page-content')[0]) return;

        hiApp.showIndicator();

        var output = appFunc.renderTpl(template);
        $$('#callView .page[data-page="call"]').html(output);

        hiApp.hideIndicator();
				
				$('#callButton').off('click');
				$('#callButton').on('click', function(){
					
				});
								
				let $elt = $('.callSwipe .tabs__link');
				$elt.off('click');
				$elt.on('click', function(){
					let idx = $('.callSwipe .tabs__link').index(this);
					callView.goToTab(idx);
				});				
				
				callView.getDidNumbers();
				callView.getCallHistory();
				
				Phone2Phone.initialize();
    },
    logOut: function(){
        hiApp.confirm(i18n.setting.confirm_logout,function(){
            //mainView.router.loadPage('page/login.html');
            //hiApp.showTab('#ourView');
        });
    },
		getDidNumbers: function() {
			var initCountry = '';
			$("#didNumbers").html('<span style="width:42px; height:42px" class="preloader telecom"></span>');
			$.ajax({url: jet_ws_end_point, dataType: 'jsonp', data:{ getDIDNumbers: callView.memberID, type: 'json' }})
			.then(function(res){
				let html = '';
				for(let i=0; i < res.length; i++) {
					let did = res[i];
					if(did['country'] != initCountry) {
						initCountry = did['country'];
						html += '<li class="list-group-title">'+did['country']+'</li>';
					}
					
					let number = did['did'];
					html += `
					<li class="contact-item">
						<a href="#" class="item-link didItem" data-did="${number}">
							<div class="item-content">
								<div class="item-inner">
									<div class="item-title-row">
										<div class="item-title">+1${number}</div>
									</div>
								</div>
							</div>
						</a>
					</li>
					`;
				}
				
				$("#didNumbers").html(html);
				
				$('.didItem, .browse-icon.phoneNumber').off('click');
				$('.didItem, .browse-icon.phoneNumber').on('click', callView.doDidCall);
				
			})
			.fail(function(err) {
				console.log(err);
			});
		},
		getCallHistory: function() {
			var initCountry = '';
			let html = '';
			
			if(!Phone2Phone.checkAuth()) {
				return;
			}
			
			$("#callHistory").html('<span style="width:42px; height:42px" class="preloader telecom"></span>');
			$.ajax({url: jet_ws_end_point, dataType: 'jsonp', data: { callHistory: callView.memberID }})
			.then(function(res){
				for(let i=0; i < res.length; i++) {
					let call = res[i];
					//{"calledstation":"00902129094798","sessionbill":"0.014549","real_sessiontime":32000,"nick":""}
					let number = call['calledstation'];
					let cost = call['sessionbill'];
					let duration = appFunc.formatTime(call['real_sessiontime']);
					html += `
					<li class="contact-item">
						<a href="#" class="item-link callHistoryItem" data-phone="${number}" data-id="hisNumber">
							<div class="item-content">
								<div class="item-inner">
									<div href="#" class="item-title-row">
										<div class="item-title">${number}</div>
									</div>
									<div href="#"class="item-subtitle">${duration}</div>
								</div>
							</div>
						</a>
					</li>
					`;
				}

				$("#callHistory").html(html);
				
				$('.callHistoryItem').off('click');
				$('.callHistoryItem').on('click', callView.setCallNumber);
				
			})
			.fail(function(err) {
				if(!Phone2Phone.checkAuth()) {
					html = $('#clickToLoginTpl').html();
				}
				
				$("#callHistory").html(html);
			});
		},
    bindEvents: function(){
        var bindings = [{
            element: '#callView',
            event: 'show',
            handler: callView.render
        },{
            element: '#callView',
            selector: '.logout-button',
            event: 'click',
            handler: callView.logOut
        },{
            element: '#callView',
            selector: '.update-button',
            event: 'click',
            //handler: callView.checkVersion
        }];
        appFunc.bindEvents(bindings);
    },
		doDidCall: function(e) {
			var elt = e.currentTarget;
			var didNumber = $(elt).data('did');
			var $input = $('#' + $(elt).data('id'));
			var dial = function(number) {
				showLoadingMask();
				$.ajax({url: jet_ws_end_point, dataType: 'jsonp', data: { updateUserDid: callView.memberID, did: didNumber, phone: number, name: 'none', type: 'json' }})
				.then(function(res){
					hideLoadingMask();
					if(res.success === false) {
						sweetAlert(res.title, res.message, "error");
						return;
					}
					window.open('tel:' + didNumber);
				})
				.fail(function(err){
					hiApp.alert(err);
				});
			}
			
			if(!navigator.contacts) return;
			
			navigator.contacts.pickContact(function(contact){
				let phoneNumbers = contact.phoneNumbers;
				let l = phoneNumbers.length;
				if(l > 1) {
					let popover = '<div class="popover phone-popover"><div class="popover-angle"></div><div class="popover-inner"><div class="list-block"><ul>';
					for(let i=0; i<phoneNumbers.length; i++) {
						let phone = phoneNumbers[i]["value"];
						popover += '<li style="text-align:left;"><a href="#" data-phone="'+phone+'" class="contactPhone list-button item-link" style="text-align:left;"><i class="fa fa-phone" style="color:green; height:0.7em; margin-top:5px;"></i> '+phone+'</a></li>';
					}
					
					popover += '</ul></div></div></div>';
					hiApp.popover(popover, elt);
					
					$(".contactPhone").off('click');
					$(".contactPhone").on('click', function(e){
						let phone = $(e.currentTarget).data("phone");
						$input.val(phone);
						hiApp.closeModal('.phone-popover');
						
						//dial(phone);
						/*
						if(/^(00)|^(011)|^(\+)/.test(phone)){
							dial(phone);
						}else{
							swal('Invalid number. Use +, 00 or 011', 'error');
						};
						*/
					});
				}else{
					let phone = phoneNumbers[0]["value"];
					$input.val(phone);
				}
			},function(err){
					console.log('Error: ' + err);
			});
		},
		setCallNumber: function(e) {
			let elt = e.currentTarget;
			let phone = $(elt).data("phone");
			let $input = $('#' + $(elt).data('id'));
			
			$input.val(phone);
			callView.goToTab(0);
		},
		goToTab: function(idx) {
			$('.call-mod .active').removeClass('active');
			$($('.call-mod .tabs__link')[idx]).addClass('active');
			$($('.call-mod div.tab')[idx]).addClass('active');
		}
};

window.callView = callView;
module.exports = callView;