require('framework7');
require('../style/less/app.less');
require('./utils/please-wait/please-wait.less');

//TODO:
// Bonjour for tv client (play on TV IP)
// Node install for chat to work

import $ from './utils/jquery-2.1.0.min';

window.jQuery = $;
window.$ = $;

window.loading_screen = {
	finish: function(){
		$('#splash').fadeOut();
		console.log("finished...");
	}
}

window.protocol = 'http:';
if (window.location.protocol == "https:"){
	protocol = 'https:';
}

// this is true if using a mobile device either with a browser or from the app
// appFunc isPhonegap only check if it's from a mobile app
window.isMobileDevice = ["android", "androidChrome", "ios", "ipad", "iphone"].filter(function(key){ return Framework7.prototype.device[key] === true; }).length !== 0;
window.onlineDomain = 'jetcamer.com';
window.offlineDomain = 'jetcamer.com';//'box.africavod.com'; //'jetcamer.local';
window.boxDomain = 'jetbox.local'; //for tv remote
window.pingRemoteUrl = protocol + '//'+onlineDomain+'/ws/json.php';
window.pingLocalUrl = protocol + '//' + offlineDomain + '/mediatheque/ws.php?action=getIP'; //protocol + '//'+offlineDomain+'/ws/json.php';
window.domain = '';
window.isJetIframe = self !== top && typeof parent.handleJetIframePlayer == 'function';

window.Phone2Phone = require('./utils/Phone2Phone');
window.LetterAvatar = require('./utils/LetterAvatar');

window.clientBoxIps = [];
window.serverBoxIps = [];

window.clientBoxPort = 2402;
window.serverBoxPort = 12;

window.setLocalisationData = function() {
	var cval = $('select[name="Countries"]').val();
	var lval = $('select[name="Languages"]').val();
	window.countries = cval ? cval.toString() : false;
    window.languages = lval ? lval.toString() : false;

    var countryBadgeContent = cval && cval.length ? cval.length : '';
    var languageBadgeContent = lval && lval.length ? lval.length : '';
    var $countryBadge = $('.smart-select .fa-globe .badge');
    var $languageBadge = $('.smart-select .fa-language .badge');

    if($.trim(countryBadgeContent) !== '') {
        $countryBadge.css('display', 'flex').html(countryBadgeContent);
	} else {
        $countryBadge.hide();
	}

    if($.trim(languageBadgeContent) !== '') {
        $languageBadge.css('display', 'flex').html(languageBadgeContent);
    } else {
        $languageBadge.hide();
    }
};

let appFunc = require('./utils/appFunc'),
    appService = require('./services/appService'),
    router = require('./router'),
    index = require('./app/app');
		
$(document).ready(function () {
	$('#connect').bind('click', function () {
		var button = $('#connect').get(0);
		if (button.value == 'connect') {
			button.value = 'disconnect';
		} else {
			button.value = 'connect';
			connection.disconnect();
		}
	});
});

var app = {
	alertItems: [],
	initialize: function() {
		this.bindEvents();
	},
	bindEvents: function() {
        appFunc.setAppMode('online');
        appFunc.isOnlineMode = true;
        appFunc.isOfflineMode = false;
        app.initAppLinks(onlineDomain);
	},
	onDeviceReady: function() {
        if(appFunc.isPhonegap()) {
        	appFunc.initPushNotification();
			if(window.screen && typeof window.screen.lockOrientation == 'function'){
				window.screen.lockOrientation('portrait');
            }
		}

		app.receivedEvent('deviceready');
		
		document.addEventListener("pause", function(){
			hideLoadingMask();
			$$('#homeView .refresh-click').find('i').removeClass('ios7-reloading');
		}, false);

		document.addEventListener("resume", function(){
			//show unread messages
			app.showUnreadMsg();
			app.showUnreadPost();
		}, false);
		
		document.addEventListener("backbutton", app.handleBackBtn, false);
						
		$(document).delegate('.open-message', 'click', function(e){
			var $el = $(e.currentTarget);
			var obj = {
				uid: $el.data("uid"),
				nickname: $el.data("nickname"),
			}
			
			message.init(obj);
		});
		
		$(document).delegate('.commentEditableContainer', 'click', function(e){
			this.focus();
		});
		
		$(document).delegate('.postCmt', 'click', function(e){
			var $el = $(e.currentTarget);
			var newsId = $el.data('id');
			commentModule.init(newsId);
			commentModule.commentPopup({});
		});
		
		appFunc.updateUserStatus();
		app.showUnreadMsg();
		app.connectChat();
		
		$('.open-popup-alerts').off('click');
		$(document).delegate('.open-popup-alerts', 'click', function(){
			showLoadingMask();
			setTimeout(function() {
				$('.prevAlertItems').remove();
				$('.badge.post').hide().html('');
				$(".alertListHidden").find(".alertListContent").appendTo(".alertList");
				hideLoadingMask();
				$(".page-content.blogAlert").scrollTop(0);
				hiApp.popup('.popup-alerts');
				$$('.popup-alerts').off('opened');
				$$('.popup-alerts').on('opened', function () {
					$(".page-content.blogAlert").scrollTop(0);
				});
			}, 200);
		});
		
		$('#ng-sendWeiboBtn').off('click');
		$('#ng-sendWeiboBtn').on('click', function(){

			let text = $("#ng-messageText").html();
			//let imgSrc = $($('.preview').find('img[ngf-src]')[0]).attr('src');

			var response = "";
			var file = "";
			var imgSrc = "";
			var type = "";
			if(window.ngUploadResp) {
				response = window.ngUploadResp;
				file = response.dir + response.data.file;
				imgSrc = response.dir + response.data.thumb;
				type = response.data.type;
			};

			appFunc.savePost(text, imgSrc, 0, '', type, '', file).then(function() {
				delete window.ngUploadResp;
			});
		});
		
		$('.recharge-credit').off('click');
		$('.recharge-credit').on('click', function(e){
			appFunc.doRecharge();
		});

		app.loadInitialAlerts();
	},
    handleBackBtn: function(e) {
        e.preventDefault();
        let isPopup = $('.popup').filter(function(idx, elt){ return $(elt).is(':visible'); }).length !== 0;
        let isPanel = $('.panel-reveal').filter(function(idx, elt){ return $(elt).is(':visible'); }).length !== 0;
        let doClosedPopup = function() {
            return $('.close-popup').filter(function(idx, elt){
                    if($(elt).is(':visible')) {
                        var t = $(elt).parents('.popup');
                        hiApp.closeModal(t);
                        return true;
                    };
                }).length !== 0;
        }

        if(isPopup) {
            doClosedPopup();
        }else if(isPanel) {
            if(doClosedPopup() !== true) {
                hiApp.closePanel();
            }
        } else {
            var currentPageId = $('.view').filter(function(){ return $(this).is(':visible'); }).attr('id');
            var selector = '#' + currentPageId;
            var currentView = hiApp.views.filter(function(elt){ return elt.selector == selector })[0];
            if(currentView) {
                currentView.router.back();
            }
            //*
            if(appFunc.isPhonegap()) {
            	if(!appFunc.isHomePage()) {
            		appFunc.showHomePage();
				} else if(appFunc.isPhonegap() && cordova.plugins.backgroundMode) {
                    cordova.plugins.backgroundMode.moveToBackground();
                }
            }
            //*/
        }

        return false;
    },
	handleBackBtn_0: function(e) {
		e.preventDefault();
		let isPopup = $('.popup').filter(function(idx, elt){ return $(elt).is(':visible'); }).length !== 0;
		let isPanel = $('.panel-reveal').filter(function(idx, elt){ return $(elt).is(':visible'); }).length !== 0;
		let doClosedPopup = function() {
			return $('.close-popup').filter(function(idx, elt){
					if($(elt).is(':visible')) {
						var t = $(elt).parents('.popup');
						hiApp.closeModal(t);
						return true;
					};
				}).length !== 0;
		}

		if(isPopup) {
			doClosedPopup();
		}else if(isPanel) {
			if(doClosedPopup() !== true) {
				hiApp.closePanel();
			}
		} else {
			var currentPageId = $('.view').filter(function(){ return $(this).is(':visible'); }).attr('id');
			var selector = '#' + currentPageId;
			var currentView = hiApp.views.filter(function(elt){ return elt.selector == selector })[0];
			if(currentView) {
				currentView.router.back();
			}
			//*
            if(appFunc.isPhonegap()) {
                if(appFunc.intvl) return;
				var count = 20;
                var getText = function() { return 'Restart the app in ' + count-- + 's ?'; };
                appFunc.intvl = setInterval(function(){
					$('.modal-text').html(getText());
					if(count == 0) {
                        location.reload();
					}
				}, 1000);

                hiApp.confirm(getText(), function () {
                    //location.reload();
                    //navigator.app.exitApp();
                }, function(){
                	clearInterval(appFunc.intvl);
                	delete appFunc.intvl;
				});
            }
			//*/
		}

		return false;
	},
	loadInitialAlerts: function () {
		$.ajax({url: jet_ws_end_point, dataType:'jsonp', method:'GET', data: {getAlerts: 1}})
		.then(function(o){
			$.each(o, function(idx, elt){
				try{
					app.alertItems.push((elt));
				}catch(e){
					console.log(e)
				}
			});

			app.displayAlertMsg();
		})
		.always(function(res){
			console.log(res)
		})
		.fail(function(e){
			console.log('Load alerts failed !');
		});
	},
	receivedEvent: function(event) {
			switch (event) {
					case 'deviceready':
							app.initMainView();
							break;
			}
	},
	initMainView:function(){
			var lang = appService.getLocal();

			switch (lang){
					case 'en-us':
							require(['./lang/en-us'], function(lang){
									window.i18n = lang;
									app.initFramework7();
							});
							break;
					case 'zh-cn':
							require(['./lang/zh-cn'], function(lang){
									window.i18n = lang;
									app.initFramework7();
							});
							break;
			}

	},
	initFramework7: function(){

			//Register custom Template7 helpers
			Template7.registerHelper('t', function (options){
					var key = options.hash.i18n || '';
					var keys = key.split('.');

					var value;
					for (var idx = 0, size = keys.length; idx < size; idx++)
					{
							if (value != null)
							{
									value = value[keys[idx]];
							} else {
									value = i18n[keys[idx]];
							}

					}
					return value;
			});

			window.$$ = Dom7;
			window.hiApp = new Framework7({
					pushState: false,
					popupCloseByOutside:false,
					animateNavBackIcon: true,
					modalTitle: i18n.global.modal_title,
					modalButtonOk: i18n.global.modal_button_ok,
					modalButtonCancel: i18n.global.cancel,
					swipePanelOnlyClose: true,
					swipePanel: 'left',
					template7Pages: true,
					template7Data: {
						'page:item': {
							back: i18n.global.back,
							title: i18n.item.title,
							comment: i18n.timeline.comment,
							forward: i18n.timeline.forward
						},
						'page:message': {
							chat: i18n.chat.title,
							chatPlaceholder: i18n.chat.chatPlaceholder,
							send: i18n.global.send
						},
						'page:feedback': {
							feedBack: i18n.setting.feed_back,
							feedBackPlaceholder: i18n.setting.feed_back_placeholder
						},
						'page:about': {
							appName: i18n.app.name,
							about: i18n.setting.about
						},
						'page:language': {
							back: i18n.global.back,
							done: i18n.global.done,
							switchLanguage: i18n.global.switch_language
						}
					}
			});
			
			window.hideLoadingMask = function() {
				hiApp.hideIndicator();
				hiApp.hideProgressbar();
                window.loading_screen && window.loading_screen.finish();
			};

			window.showLoadingMask = function() {
				hiApp.showIndicator();
				hiApp.showProgressbar();
			};

			window.homeF7View = hiApp.addView('#homeView', {
				dynamicNavbar: true
			});
			
			$$(document).on('ajaxStart', function (e) {
				//TDOD: handle before ajax here
			});
			
			$$(document).on('ajaxComplete', function (e) {
				var $els = $(".page").filter(function(){ return $(this).is(":visible"); });
			});
			

			$$('.login-screen').off('opened');
			$$('.login-screen').on('opened', function () {
				$('.sign-in').off('click');
				$('.sign-in').on('click', function(){
					var params = {};
					params.login = $('.login-screen input[name="username"]').val();
					params.password  = $('.login-screen input[name="password"]').val();
					params.beforeLogin = function() {
						showLoadingMask();
					}
					
					params.errorHandler = app.errorHandler;
					
					params.successHandler = app.successHandler;
					
					Phone2Phone.doLogin(params);
				});
				
				$('.register').off('click');
				$('.register').on('click', function(){
					var userEmail = $.trim($("#register-email").val()); 
					var userLogin = $.trim($("#register-username").val());
					var userPassword = $.trim($("#register-password").val());
					var userFullname = $.trim($("#register-name").val());
					var userPhone = $.trim($("#register-phone").val());
					var params = "doRegister=1&email=" + escape(userEmail) + "&username=" + escape(userLogin) + "&password=" + escape(userPassword) + "&fullname=" + escape(userFullname) + "&phone=" + escape(userPhone);
					
					if(userFullname.length < 5) {
						hiApp.alert("Oops. Name too short !");
						return false;
					}
					
					if(/^[0-9a-zA-Z]+$/.test(userLogin) === false) {
						hiApp.alert("Invalid username !");
						return false;
					}
					
					var re = /^(([^<>()\[\]\\.,;:\s@"]+(\.[^<>()\[\]\\.,;:\s@"]+)*)|(".+"))@((\[[0-9]{1,3}\.[0-9]{1,3}\.[0-9]{1,3}\.[0-9]{1,3}])|(([a-zA-Z\-0-9]+\.)+[a-zA-Z]{2,}))$/;
					if(re.test(userEmail) === false) {
						hiApp.alert("Invalid Email !");
						return false;
					}
					

					showLoadingMask();
					jQuery.ajax({
						data: params,
						url: jet_ws_end_point,
						dataType:"jsonp"
					})
					.then(function(data){
						if(data.success == true){
							hiApp.closeModal('.login-screen');
							Phone2Phone.doLogin({ login: userLogin, password: userPassword, successHandler: app.successHandler, errorHandler: app.errorHandler });
						}else{
							hiApp.alert(data.message);
						}
					})
					.always(function(){
						hideLoadingMask();
					});
				});
				
				$('.cancel-sign-in').off('click');
				$('.cancel-sign-in').on('click', function(){
					hiApp.closeModal('.login-screen');
					hideLoadingMask();
				});
			});
			
			$('.open-user-account').off('click');
			$('.open-user-account').on('click', function(){
				var isAuth = Phone2Phone.checkAuth();
				if(isAuth) {
					//TODO: show user profile
				}else{
					hiApp.loginScreen();
				}
			});
			
			hiApp.shareVideo = function(elt){
				appFunc.shareVideo(elt);
			}
			
			window.videoView = hiApp.addView('.view-main', {});

			window.rightView = hiApp.addView('.view-right', {});

			// init app
			router.init();
			let loadVideoOnly = false; //isJetIframe; //isJetIframe; //false; //domain === onlineDomain;

			index.init(loadVideoOnly); // if false, will show video only
			var params = appFunc.urlParams(window.location.href);
			var newsId = parseInt(params.newsId);
			if(!isNaN(newsId)) {
				showLoadingMask();
				appFunc.loadArticle(newsId);
			}
	},
	connectChat: function() {},
	showUnreadMsg: function() {
		if(!Phone2Phone.checkAuth()) return;
	},
	showUnreadPost: function() {
		if(!Phone2Phone.checkAuth()) return;
	},
	scheduleMsg: function(payload = {}) {
		var title = payload.title || "Kamer DJ";
		var text = payload.message || "Zik Non-stop.";
		var icon = payload.icon || 'res://icon';
		var smallIcon = payload.smallIcon || 'res://icon';
		var beepLocation = protocol + '//' + domain + '/mediatheque/jet_files/';
		var sound = (hiApp.device.os == 'android') ? beepLocation + 'beep.mp3' : beepLocation + 'beep.caf';
		var now = new Date().getTime();
    	var _1_sec_from_now = new Date(now + 1 * 1000);

		try{
			cordova.plugins.notification.local.on("trigger", function(notification) {
				app.vibrate();
			});
			
			cordova.plugins.notification.local.schedule({
				title: title,
				text: text,
				icon: icon,
				smallIcon: smallIcon,
				sound: sound,
				badge: 1
			});
		}catch(e){
			console.log(e);
		}
	},
	vibrate: function(time = 200) {
		navigator.vibrate(time);
		setTimeout(function(){
			navigator.vibrate(time);
		}, 500);
	},
	displayAlertMsg: function() {},
	initAppLinks: function(domain) {
		if(domain === undefined && (appFunc.isOfflineMode === undefined || appFunc.isOnlineMode === undefined)){
			return;
		}
				
		if(domain === undefined && appFunc.isOfflineMode === false && appFunc.isOnlineMode === false) {
			console.log(domain + " = " + appFunc.isOfflineMode + " = " + appFunc.isOnlineMode);
			$('#bounce-loader').html("Oops. Service not available !<br/><br/>- No / Slow internet detected.<br/>- No Jet Box detected.")
			return;
		}else if(domain === undefined) {
			return;
		}

		window.domain  = domain;
		
		window.videoPlayer = null;
		window.videoFile = null;
		window.prevFile = null;
		window.jet_ws_end_point = protocol + "//"+ domain +"/ws/json.php";
		window.ws_end_point = protocol + "//"+ domain +"/mediatheque/ws.php";
		window.thumbDir = protocol + "//"+ domain +"/mediatheque/mediaFiles/";
		window.playerDir = "./res/player/";
		window.apiUri = protocol + "//"+ domain +"/app/api/";
		window.socketUrl = protocol + "//"+ domain +":80";
		window.rechargeUrl = protocol + "//"+ domain +"/r/";
		window.mediaUploadRootUrl = protocol + "//"+ domain +"/upload/server/php/";
		window.mediaUploadUrl = mediaUploadRootUrl + 'timelinePhotoUploadHandler.php';
        window.silent_audio = protocol + "//"+ domain +"/mediatheque/1-minute-of-silence.mp3";

        //showLoadingMask();
        jQuery.ajax({
            data: {action: 'getLocalisationData'},
            url: ws_end_point,
            dataType:"jsonp"
        })
		.then(function(data){
			Object.keys(data.countries).map((k, idx) => {
				$('select[name="Countries"]').append('<option value="'+k+'" data-option-image="'+window.thumbDir+'/flags/'+k.toLowerCase()+'.gif">'+data.countries[k]+'</option>');
			});

            Object.keys(data.languages).map((k, idx) => {
				$('select[name="Languages"]').append('<option value="'+k+'" data-option-image="'+window.thumbDir+'/flags/'+data.languages[k].country.toLowerCase()+'.gif">'+data.languages[k].name+'</option>');
			});
		})
		.always(function(e){
			//hideLoadingMask();
            if(appFunc.isPhonegap()) {
                document.addEventListener('deviceready', app.onDeviceReady, false);
                if(cordova.plugins.backgroundMode) {
                    // 1) Request background execution
                    cordova.plugins.backgroundMode.enable();

                    // Disable the default msg: ...running heavy task in the background...
                    cordova.plugins.backgroundMode.setDefaults(appFunc.bgModeNotificationConfig);
                    cordova.plugins.backgroundMode.configure(appFunc.bgModeNotificationConfig);

					// 2) Now the app runs ins background but stays awake
                    // Important: Calling the method led to increased resource and power consumption.
                    // TODO: watch on this and disable it if issues
                    cordova.plugins.backgroundMode.on('activate', function() {
                        cordova.plugins.backgroundMode.disableWebViewOptimizations();
                    });

					// 3) App is back to foreground
                    cordova.plugins.backgroundMode.on('disable', function() {
                        //do something here
                    });

                    //cordova.plugins.backgroundMode.overrideBackButton();
                    cordova.plugins.backgroundMode.on('EVENT', appFunc.handleBgModeEvent);
                }
            }else{
                window.onload = app.onDeviceReady();
            }
			console.log('init error: ', e);
		});
	},
	successHandler: function(o){
		$('#login-register-form')[0].reset();
		let accountStr = JSON.stringify(o.account);
		let memberID = o.account.id;
		Phone2Phone.setCookie('accountStr', accountStr);
		Phone2Phone.setCookie('memberID', memberID);
		Phone2Phone.setCookie('card', o.account.card);
		Phone2Phone.setCookie('token', o.account.token);
		Phone2Phone.setCookie('nickname', o.username);
		Phone2Phone.setCookie('credit', o.account.credit);
		hiApp.closeModal('.login-screen');
		$$('.open-user-account').addClass('is-connected');

		hideLoadingMask();
		appFunc.updateUserStatus();
		app.showUnreadMsg();
		app.connectChat();
	},
	errorHandler: function(){
		hideLoadingMask();
		hiApp.alert("Oops. Login failed !");
	}
};

window.app = app;

app.initialize();
