require('./jquery-2.1.0.min');

let JetLazyLoad = {
	init(container) {
		let that = this;
		
		// the parent container handle: DOMContentLoaded, load and resize
		if(container){
			// Let the content fully loads
			setTimeout(()=>{
                that.handler(container);
			}, 100);
			
			//un-register previous listners
			$(container).off('DOMContentLoaded load resize');
			
			$(container).on('DOMContentLoaded load resize', (e) => {
				var container = e.currentTarget;
				that.handler(container);
			});
		}; 
		
		//un-register previous listners
		$('div').off('scroll');
			
		// the scroll event is on any div element: 
		$('div').on('scroll', (e) => {
			var el = e.currentTarget;
			that.handler(el);
		});
	},
	isElementInViewport (el) {
		//special bonus for those using jQuery
		if (typeof jQuery === "function" && el instanceof jQuery) {
			el = el[0];
		}

		let rect = el.getBoundingClientRect();

		return (
			rect.top >= 0 &&
			rect.left >= 0 &&
			rect.bottom <= (window.innerHeight || document.documentElement.clientHeight) && /*or $(window).height() */
			rect.right <= (window.innerWidth || document.documentElement.clientWidth) /*or $(window).width() */
		);
	},
	onVisibilityChange(el, callback) {
    let old_visible;
    return function () {
			let visible = isElementInViewport(el);
			if (visible != old_visible) {
				old_visible = visible;
				if (typeof callback == 'function') {
					callback();
				}
			}
    }
	},
	handler(container) {
		let that = this;
		let images = $(container).find("img.jet-lazy-load").filter(function(){ return $(this).data("isLoaded") !== "1" });
		$.each(images, function(idx, el){
			let isVisible = that.isElementInViewport(el);
			let $el = $(el);
			if(isVisible) {
				let src = $el.attr("data-src");
				let img = new Image();
				img.onload = function(){
					setTimeout(function(){
						$el.replaceWith(img);
					}, 200);
				};

				img.src = src;
			}
			//that.onVisibilityChange(el, function() {})
		})
	}
}

module.exports = JetLazyLoad;

//jQuery


/* //non-jQuery
if (window.addEventListener) {
    addEventListener('DOMContentLoaded', handler, false); 
    addEventListener('load', handler, false); 
    addEventListener('scroll', handler, false); 
    addEventListener('resize', handler, false); 
} else if (window.attachEvent)  {
    attachEvent('onDOMContentLoaded', handler); // IE9+ :(
    attachEvent('onload', handler);
    attachEvent('onscroll', handler);
    attachEvent('onresize', handler);
}
*/