require('framework7');
import africaVOD_DB from './dbController';
import {TweenMax, Power2, TimelineMax} from "gsap";

Array.prototype.inArray = function (comparer) {
    for (var i = 0; i < this.length; i++) {
        if (comparer(this[i])) return i;
    }
    return false;
};

Array.prototype.pushIfNotExist = function (element, comparer) {
    var pos = this.inArray(comparer);
    if (pos !== false) {
        //this.move(pos, appFunc.currentPos);
        console.log('found at ' + pos);
        appFunc.currentPos = pos;
    } else {
        this.splice(appFunc.currentPos, 0, element);
        console.log('inserted at ' + pos);
    }
};

Array.prototype.move = function (old_index, new_index) {
    if (new_index >= this.length) {
        var k = new_index - this.length;
        while ((k--) + 1) {
            this.push(undefined);
        }
    }
    this.splice(new_index, 0, this.splice(old_index, 1)[0]);
    return this;
};
var appFunc = {
    version: 1,
    eventScope: null,
    headerTxt: 'Non-stop music',
    mediaPlaylist: [],
    partyPlaylist:[],
    homeMediaItems: [],
    currentPos:0,
    appLocalDirName: "JetCamerDJ",
    queueMediaSuggestions: [],
    bgModeNotificationConfig : {
        title: 'Kamer-DJ',
        text: 'Non-stop Music and Fun',
        ticker: 'res/logo.png',
        //silent: true, // Only if default msg didn't change
    },
    isPhonegap: function() {
        return (typeof(cordova) !== 'undefined' || typeof(phonegap) !== 'undefined');
    },
    africaVOD_DB: africaVOD_DB,
    renderTpl: function(markup,renderData){
        var compiledTemplate = Template7.compile(markup);
        return compiledTemplate(renderData);
    },
    getQueueSuggestions: function(dataPopup) {
        var popup = dataPopup ? dataPopup : 'suggestions-popup';
        return $.ajax({url: ws_end_point, data: {action: 'getQueueSuggestions'}, dataType: 'jsonp'})
            .then(function(resp){
                let modalContent = $("[data-popup="+popup+"]").find('.page-content').html('<div class="listContainer"></div>');
                let loadMedia = function(media) {
                    let t = '';
                    appFunc.queueMediaSuggestions = media.map(function(elt){
                        elt.genre = elt.mediaGenre ? elt.mediaGenre : elt.genre;
                        elt.thumb = elt.thumb || thumbDir + elt.image;
                        elt.thumb = protocol + elt.thumb.replace('http://', '//').replace('https://', '//');
                        elt.file = elt.file ? elt.file : '';
                        if (elt.file.indexOf('youtube') != -1) {
                            elt.youtube = elt.file;
                        }

                        elt.hideDownloadLinkCls = !appFunc.isPhonegap() ? 'hiddenElt' : '';

                        t += appFunc.renderTpl($$('#videoContentTemplate').html(), elt);

                        return elt;

                    });

                    modalContent.find('.listContainer').html(t);
                    modalContent.scrollTop(0);
                };

                loadMedia(resp);
            });
    },
    isEmail: function(str){
        var reg = /^([a-zA-Z0-9_-])+@([a-zA-Z0-9_-])+((\.[a-zA-Z0-9_-]{2,3}){1,2})$/;
        return reg.test(str);
    },

    getPageNameInUrl: function(url){
        url = url || '';
        var arr = url.split('.');
        return arr[0];
    },

    isEmpty: function(obj) {
        for(var prop in obj) {
            if(obj.hasOwnProperty(prop))
                return false;
        }

        return true;
    },

    hideToolbar: function() {
        hiApp.hideToolbar('.toolbar');
    },

    showToolbar: function() {
        hiApp.showToolbar('.toolbar');
    },

    timeFormat: function(ms){

        ms = ms * 1000;

        var d_second,d_minutes, d_hours, d_days;
        var timeNow = new Date().getTime();
        var d = (timeNow - ms)/1000;
        d_days = Math.round(d / (24*60*60));
        d_hours = Math.round(d / (60*60));
        d_minutes = Math.round(d / 60);
        d_second = Math.round(d);
        if (d_days > 0 && d_days < 2) {
            return d_days + i18n.global.day_ago;
        } else if (d_days <= 0 && d_hours > 0) {
            return d_hours + i18n.global.hour_ago;
        } else if (d_hours <= 0 && d_minutes > 0) {
            return d_minutes + i18n.global.minute_ago;
        } else if (d_minutes <= 0 && d_second >= 0) {
            return i18n.global.just_now;
        } else {
            var s = new Date();
            s.setTime(ms);
            return (s.getFullYear() + '-' + f(s.getMonth() + 1) + '-' + f(s.getDate()) + ' '+ f(s.getHours()) + ':'+ f(s.getMinutes()));
        }

        function f(n){
            if(n < 10)
                return '0' + n;
            else
                return n;
        }
    },

    getCharLength: function(str){
        var iLength = 0;
        for(var i = 0;i<str.length;i++)
        {
            if(str.charCodeAt(i) >255)
            {
                iLength += 2;
            }
            else
            {
                iLength += 1;
            }
        }
        return iLength;
    },

    matchUrl: function(string){
        var reg = /((http|ftp|https):\/\/)?[\w\-_]+(\.[\w\-_]+)+([\w\-\.,@?^=%&;:\/~\+#]*[\w\-\@?^=%&;\/~\+#])?/g;

        string = string.replace(reg,function(a){
            if(a.indexOf('http') !== -1 || a.indexOf('ftp') !== -1){
                return '<a href=\"#\" onclick=\"event.stopPropagation();window.open(\'' + a + '\',\'_blank\')\">' + a + '</a>';
            }
            else
            {
                return '<a href=\"#\" onclick=\"event.stopPropagation();window.open(\'http://' + a + '\',\'_blank\')\">' + a + '</a>';
            }
        });
        return string;
    },

    bindEvents: function(bindings) {
        if(!window.$$) return;

        for (var i in bindings) {
            if(!bindings[i].event) continue;
            try{
                if(bindings[i].selector) {
                    $$(bindings[i].element)
                        .on(bindings[i].event,bindings[i].selector , bindings[i].handler);
                }else{
                    $$(bindings[i].element)
                        .on(bindings[i].event, bindings[i].handler);
                }
            }catch(e){
                console.log(e);
            }
        }
    },
    getUsers: function() {
        var search = $(".smart-select-page .searchbar-input input").val();
        var params = "getOnlineMembers=1&search=" + seoarch + "&t=" + (new Date()).getTime();
        return $.ajax({
            url: jet_ws_end_point + '?' + params,
            type: 'GET',
            dataType: 'jsonp',
            error: function(xhr, status, error) {
                console.log("error");
            },
            success: function(json) {
                return json;
            }
        });
    },
    showProfile: function(){
        let isLogged = Phone2Phone.checkAuth();
        if(isLogged) {
            let account = JSON.parse(Phone2Phone.getCookie('accountStr'));
            let id = account.id;
            let nickname = account.username;
            let avatar = account.thumb;
            let city = account.city;
            let flag = account.flag;
            let country = account.country;
            let popover = `
				<div class="popover account-popover">
					<div class="popover-angle"></div>
					<div class="popover-inner">
						<div class="list-block">
							<ul>
								<li><a href="#" class="list-button item-link my-profile">My Profile</a></li>
								<li><a href="#" class="list-button item-link logout">Logout</a></li>
							</ul>
						</div>
					</div>
				</div>
			`;

            hiApp.popover(popover, '.profile-action');
            profile.initBindings();

            $('.item-link.my-profile').off('click touchstart');
            $('.item-link.my-profile').on('click touchstart', function(){
                hiApp.closeModal('.account-popover');
                var selector = '#contactMsg';
                var socialView = hiApp.views.filter(function(elt){ return elt.selector == selector })[0];
                var user = JSON.parse(localStorage.accountStr);

                if(!user) return;

                var nickname = user.username;
                var avatar = user.thumb;
                var city = user.city;
                var country = user.country;
                var flag = user.flag;

                showLoadingMask();

                hiApp.showTab(selector);
                socialView.loadPage(`page/profile.html?nickname=${nickname}&uid=${id}&avatar=${avatar}&city=${city}&flag=${flag}&country=${country}`);
            });

            $('.item-link.logout').off('click touchstart');
            $('.item-link.logout').on('click touchstart', function(){
                hiApp.closeModal('.account-popover');
                delete localStorage.accountStr;
                delete localStorage.memberID;
                appFunc.setOnlineState();
                appFunc.updateUserStatus();
            });

            appFunc.initPhotoBrowser();
        }else{
            hiApp.loginScreen();
        }
    },
    showMediaAction: function(e){
        if(!e) return;

        let target = e.currentTarget;
        var downloadTxt = appFunc.isPhonegap() ? 'Add to playlist' : 'Download';
        let popover = `
			<div class="popover media-action-popover">
				<div class="popover-angle"></div>
				<div class="popover-inner">
					<div class="list-block">
						<ul>
							<li><a href="javascript:;" class="list-button media-action-item item-link" data-action="fbshare"><i class="fa fa-share"></i> Share media</a></li>
							<li><a href="javascript:;" class="list-button media-action-item item-link mediaDownloadCtrlElt ${nowPlayingMedia.genre}" data-action="download"><i class="fa fa-download"></i> ${downloadTxt}</a></li>
							<li><a href="javascript:;" class="list-button media-action-item item-link" data-action="watch-on-tv"><i class="fa fa-tv"></i> Watch on TV</a></li>
						</ul>
					</div>
				</div>
			</div>
		`;

        hiApp.popover(popover, target);

        $('.media-action-item').off('click touchstart');
        $('.media-action-item').on('click touchstart', function(e){
            let elt = e.currentTarget;
            hiApp.closeModal('.media-action-popover');
            hiApp.closeModal('.search-popup');
            hiApp.closeModal('.youtube');
            let action = $(elt).data('action');
            if(action == 'watch-on-tv') {
                playOnTv(elt);
            } else if(action == 'download') {
                downloadMediaLink(elt, target);
            }else if(action == 'fbshare') {
                var pid = $(elt).data('pid') || nowPlayingMedia.uri;
                var link = "http://africavod.com?src=app&uri="+pid;
                appFunc.socialShare(link);
            }
        });
    },
    showLibraryMoreOptions: function(e){
        if(!e) return;

        let target = e.currentTarget;
        let popover = `
			<div class="popover library-item-popover">
				<div class="popover-angle"></div>
				<div class="popover-inner">
					<div class="list-block">
						<ul>
							<li><a href="javascript:;" class="list-button library-action-item item-link" data-action="playNext"><i class="fa fa-angle-double-up"></i> Play next</a></li>
							<li><a href="javascript:;" class="list-button library-action-item item-link" data-action="moveup"><i class="fa fa-angle-up"></i> Move up</a></li>
							<li><a href="javascript:;" class="list-button library-action-item item-link" data-action="movedown"><i class="fa fa-angle-down"></i> Move down</a></li>
							<li><a href="javascript:;" class="list-button library-action-item item-link" data-action="deleteMedia"><i class="fa fa-trash"></i> Delete media</a></li>
						</ul>
					</div>
				</div>
			</div>
		`;

        hiApp.popover(popover, target);

        $('.library-action-item').off('click touchstart');
        $('.library-action-item').on('click touchstart', function(e){
            let elt = e.currentTarget;
            hiApp.closeModal('.library-item-popover');
            let action = $(elt).data('action');
            if(action == 'deleteMedia') {
                swal("Permanently delete this item ?", {
                    buttons: {
                        cancel: "Cancel",
                        delete: "Delete",
                    },
                })
                    .then(function(value) {
                        var idx = $($(target).parents('.listInfo')[0]).data('idx');
                        switch (value) {
                            case "delete":
                                var isQueue = $('.isQueue').is(':visible');
                                if(isQueue) {
                                    appFunc.partyPlaylist.splice(idx, 1);
                                    appFunc.refreshQueue({isQueue: true});
                                } else if(appFunc.selectedPartyPlaylist) {
                                    var mediaObj = appFunc.currentPlayistItems[idx];
                                    var mediaId = mediaObj.id;
                                    appFunc.africaVOD_DB.playlistMedia.deletePlaylistMediaItemById(mediaId, function(){
                                        appFunc.getPlaylistMediaByUri(appFunc.selectedPartyPlaylist, false, function(items) {
                                            if(items.length == 0) {
                                                appFunc.removeMediaFromDisk(mediaObj);
                                            }
                                        });
                                    }, function(){
                                        appFunc.downloadingFile = false;
                                        swal('Oops. Error !')
                                    });
                                }
                                break;

                            case "cancel":
                                swal.close();
                                break;

                            default:
                                swal.close();
                        }
                    });

            } else if(action == 'moveup') {
                appFunc.moveItemUp(target);
            } else if(action == 'movedown') {
                appFunc.moveItemDown(target);
            } else if(action == 'playNext') {
                appFunc.moveItemTop(target);
            }
        });
    },
    initPhotoBrowser: function(){
        //use delegate because photo can be added on the fly and after pge load
        $(document).delegate('.profile-photo', 'click touchstart', function(e){
            if(appFunc.slideIsOpen === true) return;

            var $this = $(e.currentTarget);
            var photos = [$this.data('photo')];
            var $others = $('.profile-photo').not($this);

            $.each($others, function(idx, el){
                photos.push($(el).data('photo'));
            });

            var slide = hiApp.photoBrowser({
                photos : photos,
                onClose: function() {
                    appFunc.slideIsOpen = false;
                }
            });

            slide.open();
            appFunc.slideIsOpen = true;
        });
    },
    getProfileCarousel: function (json) {
        var html = '';
        var genreMenu = '';
        var t = (new Date()).getTime();
        json = eval(json);


        for(var i=0; i<json.length; i++){
            var data = json[i];
            if (data.media.length < 5) continue;

            html += '<div id="carousel-image-and-text_'+i+'" class="touchcarousel grey-blue carousel-image-and-text"><div class="genre-header"><a href="#" class="genre-title">Genre: '+data.genre_name+'</a><a href="#" class="genre-more" data-genre="' + data.genre_name + '">Voir plus</a></div><ul class="touchcarousel-container" style="border-bottom:solid thin rgba(61, 76, 84, 0.8); display:table;">';
            $$.each(data.media, function(idx, el){
                var that = el;
                var uri = '';

                html += '<li class="touchcarousel-item swipebox" data-uri="'+that.uri+'" data-youtube="'+that.youtube+'" data-title="'+that.title+'" style ="padding-right:5px;"><a class="item-block jet-lazy-load-container" href="#" ><img class="jet-lazy-load"  data-src="'+thumbDir+that.image+'"/></a><p class="touchcarousel-title" style="height:60px; overflow-y:hidden; display:inline-block;">'+$("<div/>").append(that.title).text()+'</p></li>';

            });

            genreMenu += '<li><a href="#" class="item-link genre" data-genre="'+data.genre_name+'"><div class="item-content"><div class="item-inner"><div class="item-title">'+data.genre_name+'</div></div></div></a></li>';


            html += '</ul></div>';
        }

        $$(".genreContainer").html(genreMenu);

        return html;
    },
    delay: function(callback, ms){
        this.timer && clearTimeout (this.timer);
        this.timer = setTimeout(callback, ms);
    },
    share: function share(){
        var link = 'http://africavod.com/?uri=' + nowPlayingMedia.uri;
        if(appFunc.isPhonegap()){
            // this is the complete list of currently supported params you can pass to the plugin (all optional)
            var options = {
                message: nowPlayingMedia.title, // not supported on some apps (Facebook, Instagram)
                subject: 'Play this: ' + nowPlayingMedia.title, // fi. for email
                files: [nowPlayingMedia.poster], // an array of filenames either locally or remotely
                url: link,
                chooserTitle: 'Pick an app' // Android only, you can override the default share sheet title
            };

            var onSuccess = function(result) {
                console.log("Share completed? " + result.completed); // On Android apps mostly return false even while it's true
                console.log("Shared to app: " + result.app); // On Android result.app is currently empty. On iOS it's empty when sharing is cancelled (result.completed=false)
            };

            var onError = function(msg) {
                console.log("Sharing failed with message: " + msg);
            };

            window.plugins.socialsharing.shareWithOptions(options, onSuccess, onError);
            return;
        } else {
            var uri = "http://www.facebook.com/sharer.php?u=";
            var title ="";
            var url = uri + encodeURIComponent(link) + "&text="+encodeURIComponent(title)+"&t=" + (new Date()).getTime();
            return window.open(url, '_system');
        }
    },
    updateUserStatus: function() {
        if(Phone2Phone.checkAuth()) {
            let credit = Phone2Phone.getCookie('credit');
            $('.profile-action').html("Account");
            $('.credit-info').html(credit + '&euro;');
        }else{
            $('.profile-action').html("Login");
            $('.credit-info').html('');

            var html = $('#clickToLoginTpl').html();

            $("#transfertHistory").html(html);
            $("#callHistory").html(html);
        }
    },
    setOnlineState: function() {

        //*/make sure the app is ready
        try{ clearInterval(appFunc.setOnlineStateTimeout); }catch(e){}
        if(!window.$$) {
            appFunc.setOnlineStateTimeout = setTimeout(appFunc.setOnlineState, 500);
            return;
        }
        //*/

        //start with un-auth state
        var $elt = $$(".badge.user");
        $elt.removeClass("color-green").html('&Chi;');

        if(!Phone2Phone.checkAuth()) {// if user is not logged in, set state to red and stop interval
            $elt.removeClass("color-green").html('&Chi;');
            try{
                clearInterval(socketConnecting);
            }catch(e){}
        }else{// if user is connected set state to green and wait for socket connection
            $elt.addClass("color-green").html('&#x2713;');

            //when socket connect, stop interval
            if(socket.connected) {
                try{
                    clearInterval(socketConnecting);
                }catch(e){}
            }
        }

        if(socket && socket.emit) {
            var memberID = Phone2Phone.getCookie('memberID');
            var isAuth = !isNaN(parseInt(memberID, 10));
            socket.emit('auth', { success: isAuth, uid: memberID });
        }
    },
    formatTime: function (timeInMilliSec){
        var pad2 = (number) => {
            return (number < 10 ? '0' : '') + number
        }

        var time = Math.floor(timeInMilliSec/1000);
        var ts = (!isNaN(parseInt(time))) ? parseInt(time % 60) : 0;
        var tm = (!isNaN(parseInt(time))) ? parseInt((time / 60) % 60) : 0;
        var th = (!isNaN(parseInt(time))) ? parseInt(((time / 60) / 60) % 60) : 0;

        if(th>0) return pad2(th) + ':' + pad2(tm) + ':' + pad2(ts);
        return pad2(tm) + ':' + pad2(ts);
    },
    savePost: function(text, imgSrc, id=0, desc='', type='', uri='', file='', youtube='') {
        hiApp.showPreloader(i18n.index.sending);
        let img = imgSrc ? imgSrc : '';
        let token = Phone2Phone.getCookie('token');
        let params = {
            alias: Phone2Phone.getCookie('memberID') + (new Date()).getTime(),
            catid: 32,
            saveNewsToDB: 1,
            state: 1,
            text:escape(desc),
            image:(imgSrc),
            title: escape(text),
            token:Phone2Phone.getCookie('token'),
            type: type,
            id: id,
            uri: uri,
            file: file,
            youtube: youtube,
            isAppPost: true,
            poster: Phone2Phone.getCookie('username'),
        };

        //save params so it can be used later
        let postParams = params;
        postParams.paramToSave = JSON.stringify(params);

        return $.ajax({url: jet_ws_end_point, data: postParams, dataType: 'jsonp'})
            .then(function(resp){
                if(resp.success === false) {
                    hiApp.alert( "Oops. Error !" );
                }else{
                    hiApp.closeModal('.send-popup');
                    hiApp.closeModal('.upload-popup');
                }
            })
            .fail(function() {
                hiApp.alert( "Oops. Error !" );
            })
            .always(function() {
                hiApp.hidePreloader();
            });
    },
    handleCopy: function(link) {
        if(appFunc.isPhonegap()) {
            cordova.plugins.clipboard.copy(link, function() {
                let copyToast = hiApp.toast('Success !', '<div><i class="fa fa-check"></i></div>', {});
                copyToast.show();
            }, function() {
                hiApp.alert('Oops. Error !');
            });
        }else {
            window.prompt("To copy: Ctrl+C, Enter", link);
        }
    },
    getGeoLocation: function() {
        var onSuccess = function(position) {
            hiApp.alert('Latitude: '          + position.coords.latitude          + '\n' +
                'Longitude: '         + position.coords.longitude         + '\n' +
                'Altitude: '          + position.coords.altitude          + '\n' +
                'Accuracy: '          + position.coords.accuracy          + '\n' +
                'Altitude Accuracy: ' + position.coords.altitudeAccuracy  + '\n' +
                'Heading: '           + position.coords.heading           + '\n' +
                'Speed: '             + position.coords.speed             + '\n' +
                'Timestamp: '         + position.timestamp                + '\n');
        };

        // onError Callback receives a PositionError object
        //
        function onError(error) {
            hiApp.alert('code: '    + error.code    + '\n' +
                'message: ' + error.message + '\n');
        }

        try{
            var options = { enableHighAccuracy: true };
            navigator.geolocation.getCurrentPosition(onSuccess, onError, options);
        }catch(e){
            console.log(e);
        }
    },
    removeAllEventListeners: function(elt) {
        var $elt = $(elt);
        $elt.replaceWith($elt.clone());
    },
    browseYtVideo: function(initData) {
        if(!appFunc.checkNetworkStatus()) return;

        let data = initData || {};
        let word = data.search || '';

        //Important: leave default to false. Suggestion are hard to manage when added to playlist due to cloudStorageLocation
        let loadSuggestions = data.loadSuggestions || false;
        let mediaData = data.mediaData || [];
        let t = (new Date()).getTime();
        let selector = initData && initData.selector || 'youtube-popup';

        // Cleanup all event listeners on the DOM
        // because the opened/closed events a getting fired many many times
        // The .off is not cleaning-up the events
        var $elt = $("[data-popup="+selector+"]");
        if(!appFunc.searchPopupIsOpen) {
            appFunc.removeAllEventListeners($elt[0]);
        }

        //Important: do not replace this with $elt here
        let modal = $$("[data-popup="+selector+"]");
        let modalContent = modal.find('.page-content').html('');

        const showResultContent = function() {
            showLoadingMask();
            $('.youtube .page-content').scrollTop(0);
            if(loadSuggestions === true) {
                appFunc.getQueueSuggestions(selector)
                    .then(hideLoadingMask);
            } else {
                loadMedia(mediaData);
                hideLoadingMask();
            }
        };

        modal.on('closed', function() {
            appFunc.searchPopupIsOpen = false;
            modal.find('.searchbar-input input').val('');
        });

        modal.on('opened', function() {
            appFunc.searchPopupIsOpen = true;
            showResultContent();
        });

        !appFunc.searchPopupIsOpen && hiApp.popup(modal);

        let loadMedia = function(initMedia) {
            var media = initMedia ? initMedia : [];
            let t = '';
            $.each(media, function(idx, elt){
                elt.genre = elt.mediaGenre ? elt.mediaGenre : elt.genre;
                elt.thumb = elt.thumb || thumbDir + elt.image;
                elt.thumb = protocol + elt.thumb.replace('http://', '//').replace('https://', '//');
                elt.file = elt.file ? elt.file : '';
                if (elt.file.indexOf('youtube') != -1) {
                    elt.youtube = elt.file;
                }

                elt.hideDownloadLinkCls = !appFunc.isPhonegap() ? 'hiddenElt' : '';

                t += appFunc.renderTpl($$('#videoContentTemplate').html(), elt);
                //appFunc.mediaPlaylist.push({ uri: elt.uri, file: elt.file, title: elt.title });
                //elt.title + '<br/>';
            });

            modalContent.html(t);
        };

        if($.trim(word) == '') {
            return;
        }

        let languages = window.languages || '';
        let countries = window.countries || '';
        let params = { jetvideos:1, playlistJosn: word, countries:countries, languages:languages };

        var promise_1 = !appFunc.checkNetworkStatus() ? $.Deferred().resolve({}) : $.ajax({ url: 'http://jetcamer.com/yt-videos', dataType: 'jsonp', data: { search: word, isApp:1 } });
        var promise_2 = $.Deferred().resolve({}); //$.ajax({url: ws_end_point, data: params, dataType: 'jsonp'});
        return $.when(promise_1, promise_2).then(function (ytData, jetData) {
            var ytVideos = [];

            if (ytData && ytData[0] && ytData[0].items) {
                ytVideos = ytData[0].items.map(function (video, idx) {
                    var item = video;
                    item.hdImg = video.thumbnail.hqDefault;
                    item.thumb = item.hdImg;
                    item.file = "http://www.youtube.com/watch?v=" + video.id;
                    item.uri = video.id;
                    return item;
                });
            }

            var videos = ytVideos;
            hideLoadingMask();
            loadMedia(videos);

        }, function () {
            hideLoadingMask();
        });

    },
    browseSuggestedMedia: function(selector) {
        return appFunc.browseYtVideo({selector: selector});
    },
    loadMediaList: function(data) {
        let mediaArray = data.mediaArray ? data.mediaArray : [];
        let autoPlay = data.autoPlay ? data.autoPlay : false;
        let showContent = !autoPlay;
        let modal = $$("[data-popup='youtube-popup']");
        let modalContent = modal.find('.page-content');
        let media = mediaArray; //appFunc.shuffleArray(mediaArray);

        /*
         mediaArray = mediaArray.map(function (elt) {
         elt.file = elt.cloudStorageLocation + elt.file;
         return elt;
         });

         let t = '';
         $.each(media, function(idx, elt){
         if(showContent) {
         elt.thumb = thumbDir + elt.image;
         t += appFunc.renderTpl($$('#videoContentTemplate').html(), elt);
         }
         });
         */

        if(showContent) {
            appFunc.browseYtVideo({mediaData: mediaArray});
        }

        hideLoadingMask();
        if(autoPlay) {
            appFunc.mediaPlaylist = mediaArray;
            appFunc.partyPlaylist = [];
            videoPlayer.muted(false);
            delete appFunc.canPlayNext;
            delete appFunc.currentSrc;
            appFunc.playNext();
            appFunc.autostatTm && clearTimeout(appFunc.autostatTm);
            appFunc.autostatTm = setTimeout(appFunc.showHomePage, 500);
            /*
             doPlayOnMobileHandler({
             source:appFunc.mediaPlaylist[0].file,
             title: appFunc.mediaPlaylist[0].title,
             poster: appFunc.mediaPlaylist[0].thumb
             });
             */
        }
    },
    playNext_0: function() {
        if(appFunc.currentPos < appFunc.mediaPlaylist.length - 1)
            appFunc.currentPos++;
        else
            appFunc.currentPos = 0;

        appFunc.playCurrent();
    },
    playNext: function playNext() {
        if (appFunc.currentPos < appFunc.mediaPlaylist.length - 1) appFunc.currentPos++; else appFunc.currentPos = 0;

        if (appFunc.partyPlaylist.length !== 0 && !appFunc.videoid) {
            // add the 1st queue element as the next item
            //appFunc.mediaPlaylist.splice(appFunc.currentPos + 1, 0, appFunc.partyPlaylist[0]);
            appFunc.addToPlaylist(appFunc.partyPlaylist[0]);

            // move the 1st queue elt to the bottom
            appFunc.partyPlaylist.move(0, (appFunc.partyPlaylist.length-1));
        }

        return appFunc.playCurrent();
    },
    playPrev: function () {
        if (appFunc.currentPos > 0) appFunc.currentPos--; else appFunc.currentPos = appFunc.mediaPlaylist.length - 1;
        return appFunc.playCurrent();
    },
    playCurrent: function playCurrent() {
        delete appFunc.canPlayNext;
        delete appFunc.currentSrc;

        //set the user click on play button
        if (appFunc.videoid) {
            //appFunc.addToPlaylist({ uri: appFunc.videoid });
            appFunc.playFileFromPath({ mediaUri: appFunc.videoid });
            delete appFunc.videoid;
        } else {
            var videoFile = appFunc.mediaPlaylist[appFunc.currentPos];
            if(videoFile && videoFile.file) {
                doPlayOnMobileHandler({source: (videoFile.cloudStorageLocation || '') + videoFile.file, uri:videoFile.uri, title: videoFile.title, thumb: videoFile.thumb});
            } else if(videoFile && videoFile.uri){
                appFunc.playFileFromPath({ mediaUri: videoFile.uri });
            }

            if(appFunc.partyPlaylist.length > 1) {
                // refresh the queue view
                setTimeout( function(){
                    appFunc.refreshQueue();
                }, 300);
            }
        }
    },
    playCurrent_0: function() {
        appFunc.canPlayNext = true;
        try{
            window.videoFile = appFunc.mediaPlaylist[appFunc.currentPos].file;
            window.videoTitle = appFunc.mediaPlaylist[appFunc.currentPos].title;
            window.videoUri = appFunc.mediaPlaylist[appFunc.currentPos].uri;
            window.videoThumb = appFunc.mediaPlaylist[appFunc.currentPos].thumb;

            $("#carousel-container").prepend(videoFile);

            //proble: this will open the window every time
            if(videoFile) {
                doPlayOnMobileHandler({source:videoFile, title: videoTitle, thumb: videoThumb}, false);
            }else if(videoUri) {
                appFunc.playFileFromPath({ mediaUri: videoUri });
            }

        }catch(e){
            console.log(e);
        }
    },
    addToPlaylist: function addToPlaylist(obj, arr) {
        var arrObj = arr || appFunc.mediaPlaylist;
        arrObj.pushIfNotExist(obj, function (e) {
            return e.file === obj.file;
        });
    },
    addToPlaylist_0: function(obj, arr) {
        var arrObj = arr || appFunc.mediaPlaylist;
        Array.prototype.inArray = function(comparer) {
            for(var i=0; i < this.length; i++) {
                if(comparer(this[i])) return i;
            }
            return false;
        };

        Array.prototype.pushIfNotExist = function(element, comparer) {
            var pos = this.inArray(comparer);
            if (pos !== false) {
                let newPos = (appFunc.currentPos !== 0) ? (appFunc.currentPos - 1) : arrObj.length;
                this.move(pos, appFunc.currentPos);
            }else{
                this.splice(appFunc.currentPos, 0, element);
            }
        };

        Array.prototype.move = function (old_index, new_index) {
            if (new_index >= this.length) {
                var k = new_index - this.length;
                while ((k--) + 1) {
                    this.push(undefined);
                }
            }
            this.splice(new_index, 0, this.splice(old_index, 1)[0]);
            return this;
        };

        arrObj.pushIfNotExist(obj, function(e) {
            return e.file === obj.file || e.uri === obj.uri;
        });
    },
    shuffleArray: function (a) {
        var j, x, i;
        for (i = a.length; i; i -= 1) {
            j = Math.floor(Math.random() * i);
            x = a[i - 1];
            a[i - 1] = a[j];
            a[j] = x;
        }

        return a;
    },
    shareVideo: function(elt) {
        let videoElt = $(elt).closest('.video-elt'); //$(elt).parents('video-elt')[0];
        let $mediaElt = $(videoElt).find('.listInfo');
        let imgSrc = $mediaElt.data('thumb');
        let text = $mediaElt.data('title');
        let uri = $mediaElt.data('uri');
        let id = $mediaElt.data('id');
        let file = $mediaElt.data('file');
        let youtube = $mediaElt.data('youtube');
        let desc = $(videoElt).find('input.ks-messages-input').val();
        let type = 'video';

        appFunc.savePost(text, imgSrc, id, desc, type, uri, file, youtube);
    },
    showUserAccount: function() {
        let isLogged = Phone2Phone.checkAuth();
        if(isLogged) {
            let url = rechargeUrl + Phone2Phone.getCookie('memberID');
            return window.open(url, '_system');
        }else{
            hiApp.loginScreen();
        }
    },
    getProfileData: function(memberID=0) {
        return $.ajax({url: jet_ws_end_point, dataType: 'jsonp', data:{getProfileData:1, memberID: memberID}});
    },
    playFileFromPath: function(params) {
        var card = params.card || "";
        var price = params.price || "";
        var mediaUri = params.mediaUri || "";
        var action = params.action || "";
        var curType = '';
        var data = "action=buyMedia&card=" + card + "&price=" + price + "&mediaUri=" + escape(mediaUri) + "&userAction=" + action + "&type=" + curType;

        showLoadingMask();
        return $.ajax({
            type: "GET",
            url: ws_end_point,
            dataType: "jsonp",
            data: data,
            complete: function complete() {
                hideLoadingMask();
            },

            success: function success(o) {
                if (o.success === true || $.trim(card) == "") {
                    var cloudStorageLocation = o.cloudStorageLocation || '';
                    var file = o.file;
                    var genre = o.mediaGenre;
                    if ((genre == "film" || genre == "game") && $.trim(file) == "") {
                        price = o.mediaPrice;
                        appFunc.showPayBox({ price: price, mediaUri: mediaUri });
                        return;
                    } else if (action === "download") {
                        file = $.out_dir + file;
                        Phone2Phone.SaveToDisk(file, o.file);
                    } else {
                        window.nacos = {source: cloudStorageLocation + file, title: o.title, poster: thumbDir + o.image, uri: mediaUri, playlist: o.playlist};
                        if(o.nextVideo && appFunc.currentPlaylist != o.playlist) {
                            appFunc.currentPlaylist = o.playlist;
                            /*
                             appFunc.mediaPlaylist = o.nextVideo.map(function (elt) {
                             elt.file = elt.cloudStorageLocation + elt.file;
                             return elt;
                             });
                             */
                        }

                        doPlayOnMobileHandler({source: cloudStorageLocation + file, title: o.title, poster: thumbDir + o.image, uri: mediaUri, playlist: o.playlist});
                    }
                } else {
                    hiApp.alert('Oops. Process failed !');
                }
            },

            error: function error() {
                hideLoadingMask();
                hiApp.alert("An unknown error has occured.");
            }
        }).
        always(function(){
            hideLoadingMask();
        });
    },
    showPayBox: function (params) {
        var tipText = "You need a pin code to access this media.";
        var price = params.price || "";
        var mediaUri = params.mediaUri || "";
        var action = params.action || "";
        var text = params.text || "Enter your pin number - <a href='javascript:;' style='font-weight:bold;' class='hint--left helpTip' data-hint='" + tipText + "'> Help ?</a>";
        var title = params.title || "Price: " + price + " FCFA";

        if (isNaN(parseFloat(price)) || parseFloat(price) == 0) return;

        hiApp.prompt(text, title, function (inputValue) {
            if (inputValue === false) return false;

            if (inputValue === "") {
                appFunc.showPayBox(params);
                return false;
            }

            appFunc.playFileFromPath({ card: inputValue, price: price, mediaUri: mediaUri, action: action });
        });

        return false;

        swal({
            title: title,
            text: text,
            type: "input",
            html: true,
            showCancelButton: true, //important for mobile screen
            closeOnConfirm: false,
            confirmButtonColor: "#DD6B55",
            confirmButtonText: "Continue",
            cancelButtonText: "X",
            showLoaderOnConfirm: true
        }, function (inputValue) {
            if (inputValue === false) return false;

            if (inputValue === "") {
                swal.showInputError("Oops. Wrong value !");
                return false;
            }

            appFunc.playFileFromPath({ card: inputValue, price: price, mediaUri: mediaUri, action: action });
        });
    },
    setOnlineMode: function() {
        appFunc.isOnlineMode = true;
    },
    setOfflineMode: function() {
        appFunc.isOfflineMode = true;
    },
    unsetOnlineMode: function() {
        appFunc.isOnlineMode = false;
    },
    unsetOfflineMode: function() {
        appFunc.isOfflineMode = false;
    },
    setAppMode: function(mode) {
        if(mode === 'online') {
            appFunc.setOnlineMode();
            appFunc.unsetOfflineMode();
        } else if(mode === 'offline') {
            appFunc.unsetOnlineMode();
            appFunc.setOfflineMode();
        } else {
            appFunc.unsetOnlineMode();
            appFunc.unsetOfflineMode();
        }
    },
    Pinger_ping: function(ip, callback) {


        this.callback = callback
        this.ip = ip;

        var _that = this;

        this.img = new Image();

        this.img.onload = function() {
            _that.callback(true);
        };

        this.img.onerror = function(e) {
            if(_that.hasTimeout === true) return;
            _that.callback(true);
        };

        this.img.src = protocol + "//" + ip + '?t=' + new Date().getTime();;

        this.timer = setTimeout(function() {
            _that.hasTimeout = true;
            _that.callback(false);
        }, 1500);
    },
    socialShare: function(link, type, shareTitle){
        var title = shareTitle ? shareTitle : "";
        var uri = type == "twitter" ? "http://twitter.com/intent/tweet?url=" : "http://www.facebook.com/sharer.php?u=";
        var url = uri + encodeURIComponent(link) + "&text="+encodeURIComponent(title)+"&t=" + (new Date()).getTime();
        appFunc.share(url, title);
    },
    shareHandler: function(elt){
        var $that = $(elt);
        var link = $that.data("link");
        var title = $that.data("title");
        var id = $that.data("id");

        var buttons1 = [
            {
                text: 'Copy',
                onClick: function () {
                    appFunc.handleCopy(link);
                }
            }
        ];
        var buttons2 = [
            {
                text: 'Facebook',
                onClick: function () {
                    var uri = "http://www.facebook.com/sharer.php?u=";
                    var url = uri + encodeURIComponent(link) + "&text="+encodeURIComponent(title)+"&t=" + (new Date()).getTime();
                    appFunc.share(url, title, id);
                }
            },
            {
                text: 'Twitter',
                onClick: function () {
                    var uri = "http://twitter.com/intent/tweet?url=";
                    var url = uri + encodeURIComponent(link) + "&text="+encodeURIComponent(title)+"&t=" + (new Date()).getTime();
                    appFunc.share(url, title, id);
                }
            }
        ];
        var buttons3 = [
            {
                text: 'Cancel',
                color: 'red'
            }
        ];
        var groups = [buttons1, buttons2, buttons3];
        hiApp.actions(groups);
    },
    likeHandler: function(elt){
        var $that = $(elt).find('.timeline-hits');
        var $loader = $(elt).find('.fa');
        var id = $(elt).data('id');
        if(localStorage['like_' + id] !== undefined) return;
        localStorage['like_' + id] = 1;

        var count = parseInt($that.text(), 10);
        $loader.addClass('fa-spinner');
        if(isNaN(count)) count = 0;
        $.ajax({url: protocol + '//' + domain + '/ws/json.php?updateNewsView=1&id=' + id, dataType:'jsonp', success: function(resp){
            $loader.removeClass('fa-spinner');
            if(resp.success == true) $that.text(count + 1);
        }});
    },
    loadArticle: function(itemId) {
        var selector = '#homeView';
        var socialView = hiApp.views.filter(function(elt){ return elt.selector == selector })[0];
        hiApp.showTab(selector);
        homeF7View.router.loadPage('page/tweet.html?id=' + itemId + "&t=" + (new Date()).getTime());
    },
    urlParams: function (loc) {
        let url = loc || "";

        // This function is anonymous, is executed immediately and
        // the return value is assigned to urlParams !
        //result: urlParams.id, urlParams.name etc...
        var query_string = {};
        var query = url.split("?")[1];
        if(!query) return query_string;

        var vars = query.split("&");
        for (var i=0;i<vars.length;i++) {
            var pair = vars[i].split("=");
            // If first entry with this name
            if (typeof query_string[pair[0]] === "undefined") {
                query_string[pair[0]] = pair[1];
                // If second entry with this name
            } else if (typeof query_string[pair[0]] === "string") {
                var arr = [ query_string[pair[0]], pair[1] ];
                query_string[pair[0]] = arr;
                // If third or later entry with this name
            } else {
                query_string[pair[0]].push(pair[1]);
            }
        }
        return query_string;
    },
    handleBgModeEvent: function(event) {

    },
    getFileName: function(path) {
        return path.replace(/^.*[\\\/]/, '');
    },
    readLocalDir: function(dirName) {
        if (appFunc.isAndroid()) {
            window.resolveLocalFileSystemURL(cordova.file.externalRootDirectory, onFileSystemSuccess, onError);
        } else {
            // for iOS
            window.requestFileSystem(LocalFileSystem.PERSISTENT, 0, onFileSystemSuccess, onError);
        }

        function onError(e) {
            swal('Oops. Downloading Failed', '', 'error');
        };

        function onSuccess(e) {
            swal('Success', '', 'success');
        };

        function onFileSystemSuccess(fileSystem) {
            var entry = "";
            if (appFunc.isAndroid()) {
                entry = fileSystem;
            } else {
                entry = fileSystem.root;
            }

            // Creates or looks up an existing directory. It is an error to attempt to:
            // create a directory whose immediate parent does not yet exist.
            entry.getDirectory(appFunc.appLocalDirName, {
                create: true,
                exclusive: false
            }, onGetDirectorySuccess, onError);
        };

        function onGetDirectorySuccess(dir) {
            hiApp.alert(JSON.stringify(dir));
            var reader = dir.createReader();
            reader.readEntries(
                function (entries) {
                    entries.forEach((entry) => {
                        //$("#carousel-container").html(entry.nativeURL);
                        //videoPlayer.src(entry.nativeURL).play();
                    });
                },
                function (err) {
                    console.log(err);
                }
            );
        };
    },
    saveFileToLocal: function(mediaObj) {
        appFunc.manageMediaFileOnDisk(mediaObj, 'create');
    },
    removeMediaFromDisk: function (mediaObj) {
        appFunc.manageMediaFileOnDisk(mediaObj, 'remove');
    },
    manageMediaFileOnDisk: function(mediaObj, action) {
        let fileTransfer = new FileTransfer();
        let fileUrl = (mediaObj.cloudStorageLocation || '') + mediaObj.file;
        let filename = appFunc.getFileName(fileUrl);

        (function() {

            if (appFunc.downloadingFile) {
                swal('In progress. Please wait !');
                return;
            };

            appFunc.downloadingFile = true;

            fileTransfer.onprogress = function (progressEvent) {
                if (progressEvent.lengthComputable) {
                    var perc = Math.floor(progressEvent.loaded / progressEvent.total * 100);
                    $('#progressRate').html(perc + "%");
                }
            };

            if (appFunc.isAndroid()) {
                window.resolveLocalFileSystemURL(cordova.file.externalRootDirectory, onFileSystemSuccess, onError);
            } else {
                // for iOS
                window.requestFileSystem(LocalFileSystem.PERSISTENT, 0, onFileSystemSuccess, onError);
            }

            function onError(e) {
                hiApp.hidePreloader();
                appFunc.downloadingFile = false;
                swal('', JSON.stringify(e), 'error');
            };

            function dbSaveError() {
            }

            function dbSaveSuccess() {
            }

            function onSuccess(e) {
                hiApp.hidePreloader();
                hiApp.showPreloader('Saving media...');
                mediaObj.thumb = mediaObj.thumb || thumbDir + mediaObj.image;
                mediaObj.cloudStorageLocation = appFunc.cdr.nativeURL;
                mediaObj.file = filename;

                var thumbName = appFunc.getFileName(mediaObj.thumb);
                var uri = encodeURI(mediaObj.thumb);
                fileTransfer.download(uri, appFunc.cdr.nativeURL + thumbName, function() {
                    mediaObj.thumb = appFunc.cdr.nativeURL + thumbName;
                    var playlistUri = appFunc.selectedPartyPlaylist ? appFunc.selectedPartyPlaylist : false;
                    appFunc.africaVOD_DB.playlistMedia.insertPlaylistMedia(playlistUri, [mediaObj], function(){
                        appFunc.downloadingFile = false;
                        hiApp.hidePreloader();
                        swal('Success', '', 'success');
                        appFunc.getPlaylistMediaByUri(appFunc.selectedPartyPlaylist);
                    }, function(){
                        appFunc.downloadingFile = false;
                        hiApp.hidePreloader();
                        swal('Oops. Error !')
                    });
                }, onError, false);

                /*
                 appFunc.getImgBase64Data(mediaObj.thumb, function(dataUrl) {
                 mediaObj.thumb = dataUrl;
                 mediaObj.title = dataUrl;

                 });
                 */
            };

            function onFileSystemSuccess(fileSystem) {
                var entry = "";
                if (appFunc.isAndroid()) {
                    entry = fileSystem;
                } else {
                    entry = fileSystem.root;
                }

                // Creates or looks up an existing directory. It is an error to attempt to:
                // create a directory whose immediate parent does not yet exist.
                entry.getDirectory(appFunc.appLocalDirName, {
                    create: true,
                    exclusive: false
                }, onGetDirectorySuccess, onError);
            };

            function onGetDirectorySuccess(dir) {
                appFunc.cdr = dir;
                // Creates or looks up an existing file. It is an error to attempt to:
                // create a file whose immediate parent dir does not yet exist.
                dir.getFile(filename, {
                    create: true,
                    exclusive: false
                }, gotFileEntry, onError);
            };

            function gotFileEntry(fileEntry) {
                var uri = encodeURI(fileUrl);
                swal.close();
                if(action == 'create') {
                    hiApp.showPreloader('<span id="progressRate"></span> Downloading...');
                    fileTransfer.download(uri, appFunc.cdr.nativeURL + filename, onSuccess, onError, false);
                } else if(action == 'remove') {
                    fileEntry.remove(function(){
                        // The file has been removed succesfully
                        hiApp.hidePreloader();
                    }, onError, function(){
                        // The file doesn't exist
                    });
                }
            };
        }())
    },
    deleteLibraryMedia: function(mediaObj) {
        /*// File and image might be used by many media
         window.resolveLocalFileSystemURL(mediaObj.cloudStorageLocation, function(dir) {
         dir.getFile(mediaObj.file, {create:false}, function(fileEntry) {
         fileEntry.remove(function(){}, null, null);
         });

         var thumb = appFunc.getFileName(mediaObj.thumb);
         dir.getFile(thumbName, {create:false}, function(fileEntry) {
         fileEntry.remove(function(){}, null, null);
         });
         });
         */
    },
    requestFilesystemAccessPermission: function(onSuccess, onError) {
        let doRequest = function() {
            if (appFunc.isAndroid()) {
                window.resolveLocalFileSystemURL(cordova.file.externalRootDirectory, onFileSystemSuccess, onError);
            } else {
                // for iOS
                window.requestFileSystem(LocalFileSystem.PERSISTENT, 0, onFileSystemSuccess, onError);
            }

            function onFileSystemSuccess(fileSystem) {
                var entry = "";
                if (appFunc.isAndroid()) {
                    entry = fileSystem;
                } else {
                    entry = fileSystem.root;
                }

                // Creates or looks up an existing directory. It is an error to attempt to:
                // create a directory whose immediate parent does not yet exist.
                entry.getDirectory(appFunc.appLocalDirName, {
                    create: true,
                    exclusive: false
                }, onSuccess, onError);
            };
        }

        swal("To continue, we need permission to save files in your device", {
            buttons: {
                cancel: "Cancel",
                continue: {
                    text: 'Continue',
                    value: 'continue',
                },
            },
        })
        .then(function(value) {
            switch (value) {
                case "continue":
                    alert('cool !')
                    break;
                default:
                    swal.close();
            }
        });

    },
    isAndroid: function() {
        return hiApp.device.os == 'android';
    },
    refreshQueue: function(initParams) {
        let params = initParams ? initParams : {};
        let queueCls = 'isQueue';
        let queueHeaderClass = params.isQueue ? queueCls : '';
        let isQueue = (!appFunc.selectedPartyPlaylist || params.isQueue);
        let playlistTitle = appFunc.selectedPartyPlaylistTitle ? appFunc.selectedPartyPlaylistTitle : '';
        let dom = isQueue ? '<div class="${queueHeaderClass}"/>' : `<div class="playlistHeadingContent"><div class="button_style_5"><div class="account_btn"><a href="javascript:;" onclick="appFunc.playAll()" class="but2 playAllBtn"><span class="title">Play all</span><span class="fa fa-play"></span></a><a href="javascript:;" class="but2 add-media-link"><span class="title">Add media</span><span class="extra" style="display:none;"><input type="text"></span><span class="fa fa-pencil"></span></a><a href="javascript:;" data-page="home" class="but2 playlistLink"><span class="title">Playlist</span><span class="fa fa-list"></span></a></div><div class="selectedPlaylistTitle">${playlistTitle}</div></div></div>`;
        let videos = appFunc.partyPlaylist.map(function (item, idx) {
            item.idx = idx;
            item.pos = idx+1;
            item.genre = item.mediaGenre ? item.mediaGenre : item.genre;
            dom += appFunc.renderTpl($$('#partyPlaylistItem').html(), item);
            return item;
        });

        let $container = $("#carousel-container");
        if(isQueue) {
            $container.addClass(queueCls);
        } else {
            $container.removeClass(queueCls);
        }

        if(params.showList === true) {
            $container.html(dom);
        }

        if(videos.length == 0) {
            $container.append('<img class="emptyResult" src="res/empty.png"/>');
        }

        if(isQueue && appFunc.partyPlaylist.length == 0) {
            return;
        }

        if(appFunc.isPhonegap() && isQueue) {
            appFunc.africaVOD_DB.userPreferences.saveUserPreference(appFunc.africaVOD_DB.partyPlaylistPrefName, JSON.stringify(appFunc.homeMediaItems));
        }
    },
    showUserPlaylist: function(dataInput){
        var data = dataInput ? dataInput : {};
        var taget = data.popupTarget || '.playlistLink';
        var callback = data.callback || function(){};
        var isSave = data.isSave || 0;
        var successCb = function(rows) {
            let li = "";
            for(let i=0; i< rows.length; i++) {
                let uri= rows[i].uri;
                let title = rows[i].title;
                li += `<li style="display: flex; align-items: center; padding: 5px; border-top: solid thin #ccc;">
						<div class="playlist-action-item" data-issave = '${isSave}' data-title="${title}" data-uri="${uri}" style="width: calc(100% - 20px);float:left;text-overflow: ellipsis;white-space: nowrap;overflow: hidden;">${title}</div>
						<div class="deletePlaylistLink" data-uri="${uri}" data-title="${title}" style="float:left;width: 20px;text-align: right;display: flex;align-items: center;justify-content: flex-end;"><i class="fa fa-trash" style="height: auto; font-size: 1.2em; line-height: normal;"></i></div>
					 </li>`;
            }
            let popover = `
				<div class="popover playlist-item-popover">
					<div class="popover-angle"></div>
					<div class="popover-inner">
						<div class="list-block">
							<div style="height:40vh; overflow-y: auto">
								<div style="height:30px; text-align:center;">
									<a href="javascript:;" class="createNewPaylist">
										<span class="createNewPaylistLabel">
											Create new plalist
										</span>
									</a>
								</div>
								<div style="height:calc(100% - 30px); overflow-y:auto">
									<ul>${li}</ul>
								</div>
							</div>
						</div>
					</div>
				</div>
			`;

            hiApp.popover(popover, taget);
            hideLoadingMask();

            $('.playlist-action-item').off('click');
            $('.playlist-action-item').on('click', function(e) {
                if(!Phone2Phone.checkAuth()) {
                    hiApp.loginScreen();
                } else {
                    const $elt = $(e.currentTarget);
                    const $parent = $($(taget).parents('.listInfo')[0]);
                    const isSave = parseInt($elt.data('issave')) == 1;
                    const videoid = $parent.data('uri');
                    const title = $parent.data('title');
                    const thumb = $parent.data('thumb');
                    const file = $parent.data('file');
                    const playlistUri = $(e.currentTarget).data('uri');
                    const mid = parseInt(Phone2Phone.getCookie("memberID"), 10);
                    if(isSave) {
                        hiApp.closeModal('.playlist-item-popover');
                        showLoadingMask();
                        $.ajax({url: jet_ws_end_point, dataType:'jsonp', data:{ mid:mid, saveVideoPlaylistMedia: videoid, file: file, thumb: thumb, playlistUri: playlistUri, title: escape(title) }}).then(function (data) {
                            hideLoadingMask();
                            if(data.success) {
                                appFunc.showPlaylistMedia(e);
                            } else {
                                swal("Oops. Error!", "Delete failed", "error");
                            }

                        }, function() {
                            hideLoadingMask();
                            swal("Oops. Error!", "", "error");
                        });
                    } else {
                        hideLoadingMask();
                        appFunc.showPlaylistMedia(e);
                    }
                }
            });

        };

        var errorCb = function() { hideLoadingMask(); swal('Oops. Error !')};
        var mid = localStorage.memberID || 0;
        showLoadingMask();
        $.ajax({ url: jet_ws_end_point, dataType: 'jsonp', data: { getUserPlaylist: 1, memberID: mid } })
        .then(successCb, errorCb);
    },
    playAll: function() {
        appFunc.getPlaylistMediaByUri(appFunc.selectedPartyPlaylist, function(items) {
            if(items.length > 0) {
                appFunc.partyPlaylist = [];
                appFunc.mediaPlaylist = appFunc.shuffleArray(items);
                appFunc.playNext();
            }

            hideLoadingMask();
        });
    },
    showPlaylistMedia: function(e) {
        hiApp.closeModal('.playlist-item-popover');
        showLoadingMask();
        appFunc.selectedPartyPlaylist = $(e.currentTarget).data('uri');
        appFunc.selectedPartyPlaylistTitle = $(e.currentTarget).data('title');
        appFunc.getPlaylistMediaByUri(appFunc.selectedPartyPlaylist);
    },
    getPlaylistMediaByUri: function(playlistUri, callback, callback2) {
        var errorCb = function(e) { hideLoadingMask(); swal(JSON.stringify(e) + 'Oops. Error !')};
        var successCb = function(videos) {
            var items = videos ? videos : [];
            if(callback && (typeof callback == 'function')) {
                callback(items);
            } else {
                hideLoadingMask();
                var tmpPl = appFunc.partyPlaylist;
                appFunc.partyPlaylist = items;
                appFunc.currentPlayistItems = items;
                appFunc.refreshQueue({isDirty: false, showList: true});
                appFunc.partyPlaylist = tmpPl;
            }

            if(callback2 && (typeof callback2 == 'function')) {
                callback2(items);
            }
        };

        showLoadingMask();
        $.ajax({ url: jet_ws_end_point, dataType: 'jsonp', data: { playlistJosn: '', type: 'video', subType: 'playlist', subTypeValue: playlistUri } })
        .then(successCb, errorCb);
    },
    getPreferenceByName: function(name, callback) {
        if(!appFunc.isPhonegap() || 1==1) {
            return (typeof callback == 'function') && callback(false);
        }

        var errorCb = function() { hideLoadingMask(); swal('Oops. Error !')};
        var successCb = function(tx, result) {
            let pref = false;
            if (result.rows.length > 0) {
                pref = result.rows.item(0).prefValue;
            }

            (typeof callback == 'function') && callback(pref);
        };

        appFunc.africaVOD_DB.userPreferences.getPreferenceByName(name, successCb, errorCb);
    },
    savePreferenceByName: function(name, value, callback, errorCb) {
        if(!appFunc.isPhonegap()) {
            (typeof callback == 'function') && callback(false);
            return;
        }

        appFunc.africaVOD_DB.userPreferences.saveUserPreference(name, value, callback, errorCb);
    },
    clearQueue: function() {
        appFunc.partyPlaylist = [];
        delete appFunc.selectedPartyPlaylist;
        appFunc.refreshQueue();
    },
    saveQueue: function () {
        var title = "Create new playlist";
        if(!appFunc.selectedPartyPlaylist) {
            return appFunc.createPlaylist();
        } else {
            swal("Where to save the queue ?", {
                buttons: {
                    selected: {
                        text: "Selected playlist",
                        value: "selected",
                        className:"swalSelected"
                    },
                    createNew: {
                        text: "New playlist",
                        value: "createNew"
                    },
                },
            })
            .then(function(value) {
                switch (value) {
                    case "selected":
                        appFunc.saveSelectedPlaylist();
                        break;
                    case "createNew":
                        appFunc.createPlaylist({medias:appFunc.partyPlaylist});
                        break;
                    default:
                        swal.close();
                }
            });
        }
    },
    createPlaylist: function (params) {
        const medias = params && params.medias ? params.medias : false;
        hiApp.closeModal('.playlist-item-popover');
        var title = "Create new playlist";
        const mid = parseInt(Phone2Phone.getCookie("memberID"), 10);
        hiApp.prompt(title, function (inputValue) {
            if (!inputValue) return false;
            showLoadingMask();
            var errorCb = function(e) { hideLoadingMask(); swal('Oops. Error!') };
            var successHandler = function() { appFunc.showUserPlaylist(); hideLoadingMask();};
            var data = { createPlaylist: 1, title: inputValue, mid: mid, country: '' };
            $.ajax({url:jet_ws_end_point, method: "post", dataType:'json', data:data}).then(successHandler, errorCb);
        });
    },
    saveSelectedPlaylist: function() {
        showLoadingMask();
        var errorCb = function() { hideLoadingMask(); swal('Oops. Error!') };
        var successCb = function() { hideLoadingMask(); swal('Success !') };
        var playlistUri = appFunc.selectedPartyPlaylist ? appFunc.selectedPartyPlaylist : false;
        appFunc.africaVOD_DB.playlistMedia.updatePlaylistMedia(playlistUri, appFunc.partyPlaylist, successCb, errorCb);
    },
    deletePlaylist: function(e) {
        if(!e) return;

        let playlistUri = $(e.currentTarget).data('uri');
        let title = $(e.currentTarget).data('title');
        let page = $(e.currentTarget).data('page');
        var isQueue = $('.isQueue').is(':visible');
        const mid = parseInt(Phone2Phone.getCookie("memberID"), 10);

        swal({
            title: "Delete this playlist ?",
            text: title,
            icon: "warning",
            buttons: true,
            dangerMode: true,
        })
        .then(function(yesDelete) {
            if (yesDelete) {
                hiApp.closeModal('.playlist-item-popover');
                var successCb = function() {
                    appFunc.showUserPlaylist();
                    return hideLoadingMask();
                };

                var errorCb = function(e) { hideLoadingMask(); swal('Oops. Error!') };

                showLoadingMask();
                $.ajax({url:jet_ws_end_point, dataType:'jsonp', data:{ deletePlaylist: 1, uri: playlistUri, mid: mid }}).then(successCb, errorCb);
            }
        });

    },
    convertToSlug: function(Text){
        return Text
            .toLowerCase()
            .replace(/ /g,'-')
            .replace(/[^\w-]+/g,'');
    },
    getImgBase64Data: function (src, callback, outputFormat) {
        var img = new Image();
        img.crossOrigin = 'Anonymous';
        img.onload = function() {
            var canvas = document.createElement('CANVAS');
            var ctx = canvas.getContext('2d');
            var dataURL;
            canvas.height = this.naturalHeight;
            canvas.width = this.naturalWidth;
            ctx.drawImage(this, 0, 0);
            dataURL = canvas.toDataURL(outputFormat);
            callback(dataURL);
        };
        img.src = src;
        if (img.complete || img.complete === undefined) {
            img.src = "data:image/gif;base64,R0lGODlhAQABAIAAAAAAAP///ywAAAAAAQABAAACAUwAOw==";
            img.src = src;
        }
    },
    checkNetworkStatus: function(showAlert) {
        if(!appFunc.isPhonegap()) return true;

        var networkState = navigator.connection.type;

        var states = {};
        states[Connection.UNKNOWN]  = 'Unknown connection';
        states[Connection.ETHERNET] = 'Ethernet connection';
        states[Connection.WIFI]     = 'WiFi connection';
        states[Connection.CELL_2G]  = 'Cell 2G connection';
        states[Connection.CELL_3G]  = 'Cell 3G connection';
        states[Connection.CELL_4G]  = 'Cell 4G connection';
        states[Connection.CELL]     = 'Cell generic connection';
        states[Connection.NONE]     = 'No network connection';

        if(networkState == Connection.NONE) {
            if(showAlert !== false) swal('Oops !', 'No network connection');
            return false;
        }

        return true;
    },
    initPushNotification: function(senderID) {
        /*
        var push = PushNotification.init({
            android: {
                "senderID": senderID,
            },
            browser: {},
            ios: {
                alert: "true",
                badge: "true",
                sound: "true"
            },
            windows: {}
        });

        push.on('registration', function (data) {
            if(appFunc.checkNetworkStatus(false)) {
                $.ajax({url: ws_end_point, data: {action: 'saveDeviceId', id: data.registrationId}, dataType: 'jsonp'});
            }
        });

        push.on('notification', function (data) {
            console.log(data);
        });

        push.on('error', function (err) {
            console.log(err);
        });
        */
    },
    moveItemTop: function (elt) {
        var $parent = $($(elt).parents('.listInfo')[0]);
        var currentIdx = parseInt($parent.data('idx'), 10);
        if(currentIdx > 0) {
            appFunc.partyPlaylist.move(currentIdx, 0);
            setTimeout( function(){
                appFunc.refreshQueue({isQueue: true});
            }, 100);
        }
    },
    moveItemDown: function (elt) {
        var $parent = $($(elt).parents('.listInfo')[0]);
        var currentIdx = parseInt($parent.data('idx'), 10);
        if(currentIdx < (appFunc.partyPlaylist.length - 1)) {
            appFunc.partyPlaylist.move(currentIdx, (currentIdx+1));
            setTimeout( function(){
                appFunc.refreshQueue({isQueue: true});
            }, 100);
        }
    },
    moveItemUp: function (elt) {
        var $parent = $($(elt).parents('.listInfo')[0]);
        var currentIdx = parseInt($parent.data('idx'), 10);
        if(currentIdx > 0) {
            appFunc.partyPlaylist.move(currentIdx, (currentIdx-1));
            setTimeout( function(){
                appFunc.refreshQueue({isQueue: true});
            }, 100);
        }
    },
    moveItemBottom: function (elt) {
        var $parent = $($(elt).parents('.listInfo')[0]);
        var currentIdx = parseInt($parent.data('idx'), 10);
        if(currentIdx < (appFunc.partyPlaylist.length - 1)) {
            appFunc.partyPlaylist.move(currentIdx, (appFunc.partyPlaylist.length - 1));
            setTimeout( function(){
                appFunc.refreshQueue({isQueue: true});
            }, 100);
        }
    },
    setBtnCtrlState() {
        let $playBtn = $('.video-player-popup .btn-play, .homeLabelContainer .icon.homePlayBtn');
        let $pauseBtn = $('.video-player-popup .btn-pause, .homeLabelContainer .icon.homePauseBtn');
        let clickEnv = appFunc.isPhonegap() ? 'touchstart' : 'click';

        $pauseBtn.off(clickEnv);
        $pauseBtn.on(clickEnv, function () {
            videoPlayer.pause();
        });

        $playBtn.off(clickEnv);
        $playBtn.on(clickEnv, function () {
            const isInit = (videoPlayer && videoPlayer.src && (videoPlayer.src() == silent_audio));
            console.log('isInit: ', isInit);
            if(!videoPlayer || isInit) {
                appFunc.playNext();
            } else if(videoPlayer) {
                videoPlayer.play();
            }
        });

        $('.btn-zoom-in').off(clickEnv);
        $('.btn-zoom-in').on(clickEnv, function () {
            videoPlayer.requestFullscreen();
        });

        $('.btn-zoom-out').off(clickEnv);
        $('.btn-zoom-out').on(clickEnv, function () {
            $(this).hide();
            $('.btn-zoom-in').show();
            $('.picker-modal').removeClass('fullscreen');
        });

        if(!window.videoPlayer || (videoPlayer && videoPlayer.paused()) || appFunc.homeBtnInitialized !== true) {
            $playBtn.removeClass('playerBtnHidden');
            $pauseBtn.addClass('playerBtnHidden');
        } else {
            $playBtn.addClass('playerBtnHidden');
            $pauseBtn.removeClass('playerBtnHidden');
            window.nowPlayingMedia && $('x-sign').html(nowPlayingMedia.title);
        }
    },
    updateMiniPlayerBg: function(thumb) {
        let eltId = 'miniPlayerBg';
        $('#' + eltId).remove();
        $('head').append(
            $('<style/>', {
                id: eltId,
                html: `.video-player-popup.minimized .toolbar-inner {background-image: url('${thumb}'); }`
            })
        );
    },
    isHomePage: function() {
        return $('.africaMap').length > 0;
    },
    showHomePage: function(idx) {
        // Stop here if it's already the home page
        if(appFunc.isHomePage()) return;

        let clickEnv = appFunc.isPhonegap() ? 'touchstart' : 'click';
        let killInstance = function() {
            appFunc.pulseTl && appFunc.pulseTl.kill() && (appFunc.pulseTl=null);
            appFunc.hoverTl && appFunc.hoverTl.kill() && (appFunc.hoverTl=null);
            appFunc.spinTl && appFunc.spinTl.kill() && (appFunc.spinTl=null);
            appFunc.tweenMax && appFunc.tweenMax.kill() && (appFunc.tweenMax=null);
            appFunc.animTm && clearTimeout(appFunc.animTm);
        };

        let html = `
            <div class="africaMap" style="background: url(res/africa.svg);"></div>
			<div class="homeLabelContainer">
			    <x-sign data-idx="4">Latest Music Hits</x-sign>
				<div class="play-button">
				  <div class="circle">
				  	  <div class="icon fast-backward" style="display: table; right:71px !important; left:auto !important; padding:5px; top: calc(50% - 5px)"><i class="fa fa-fast-backward"></i></div>
					  <div class="icon fast-forward" style="display: block; right:-55px !important; left:auto !important;  padding:5px; top: calc(50% - 5px)"><i class="fa fa-fast-forward"></i></div>
					  <div class="icon homePauseBtn playerBtnHidden" style="padding: 5px; top: calc(50% - 5px); left: calc(50% - 5px); display: block;"><i class="fa fa-pause"></i></div>
					  <div class="icon homePlayBtn" style="padding:5px; top: calc(50% - 5px); left: calc(50% - 5px);"><i class="fa fa-play"></i></div>
					  <div class="black"><svg height="62" width="62"><circle cx="31" cy="31" r="8" fill="transparent" stroke="#171521" stroke-width="2" /></svg></div>
					  <div class="border"><svg height="72" width="72"><circle cx="36" cy="36" r="36" fill="transparent" stroke="#f3d178" stroke-width="1" stroke-dasharray="4,3" /></svg></div>
					  <div class="white"><svg height="120" width="120"><circle cx="60" cy="60" r="33" fill="#fff" /></svg></div>
					  <div class="lines"></div>
				  </div>
			  </div>
			
			  <button class="explore liveLinkkk home-tab-link" data-station="1" data-genre="audio">
				<i class="fa fa-music" style="font-size:1em; margin-right:5px;"></i>
				Zik Station
			  </button>
			</div>
		`;

        killInstance();

        $('#carousel-container').html(html);

        var height = Math.abs(parseInt($('.titlebar').offset().top - $('#bottomToolbar').offset().top)) - 50;

        $('#carousel-container').css({"min-height":height+"px"});

        var self = this;

        var $playBtn = $('.play-button');
        TweenMax.set($playBtn.find('circle'), { transformOrigin: "center center" });

        self.pulseTl = new TimelineMax({ yoyo: true, repeat: -1 });
        self.pulseTl.fromTo($playBtn.find('.white'), 2, { scale: 1 }, { scale: 1.2, ease: Power2.easeInOut });

        self.spinTl = new TimelineMax({ repeat: -1 });
        self.spinTl.to($playBtn.find('.border'), 5, { rotation: 360, ease: Linear.easeNone });

        var onReverse = function() {
            var self = this;
            self.pulseTl.resume();
            self.spinTl.pause();
        };

        self.hoverTl = new TimelineMax({ paused: true, onReverseComplete: onReverse, onReverseCompleteScope: self });
        self.hoverTl.to($playBtn.find('.black circle'), .25, { scale: 0, ease: Circ.easeIn }, "start")
            .to($playBtn.find('.yellow circle'), .45, { scale: 0, ease: Circ.easeIn }, "start")
            .set($playBtn.find('.black circle'), { fill: '#171521' })
            .set($playBtn.find('.icon'), { display: 'block' })
            .to($playBtn.find('.black circle'), .20, { scale: 3.4, ease: Circ.easeOut }, "end")
            .from($playBtn.find('.border circle'), .35, { scale: 0, ease: Circ.easeOut }, "end")
            .to($playBtn.find('.white circle'), .45, { scale: 1.4, ease: Back.easeOut }, "end")
            .to($playBtn.find('.text'), .55, { y: 15, ease: Back.easeOut }, "end");
        self.hoverTl.timeScale(1.1);

        $('.play-pause').off(clickEnv);
        $('.play-pause').on(clickEnv, appFunc.playNext);

        $('.fast-backward').off(clickEnv);
        $('.fast-backward').on(clickEnv, appFunc.playPrev);

        $('.fast-forward').off(clickEnv);
        $('.fast-forward').on(clickEnv, appFunc.playNext);

        self.pulseTl.pause();
        self.hoverTl.play();
        self.spinTl.play();

        appFunc.animTm = setTimeout(killInstance, 10000);

        appFunc.initHomeSign();
        appFunc.setBtnCtrlState();
    },
    initHomeSign: function() {
        const $signs = $('x-sign');
        (function flick(){
            var idx = Math.floor(Math.random() * 9) + 1;
            $signs.attr('data-idx', idx);
            appFunc.tweenMax = TweenMax.to($signs, 3, {'data-idx': idx, onComplete:flick});
        }());

        const randomIn = (min, max) => (
            Math.floor(Math.random() * (max - min + 1) + min)
        );

        const mixupInterval = el => {
            const ms = randomIn(2000, 4000)
            el.style.setProperty('--interval', `${ms}ms`)
        }

        mixupInterval($signs[0])
        $signs[0].addEventListener('webkitAnimationIteration', () => {
            mixupInterval($signs[0]);
        });
    },
    prepareNextSong_0: function() {
        var source = appFunc.partyPlaylist[0] ? appFunc.partyPlaylist[0].file : false;
        if(!source) return;
        var uri = appFunc.partyPlaylist[0].uri;
        if (source && source.indexOf('youtube') != -1) {
            return $.ajax({
                url: ws_end_point,
                type: 'GET',
                data: {uri: uri, action:'prepareNextSong'},
                dataType: 'jsonp',
                error: function(xhr, status, error) {
                    console.log("error");
                },
                success: function(json) {
                    if(json.success) {
                        console.log(json.file);
                        $.each(appFunc.partyPlaylist, (idx, elt) => {
                            if(elt.uri == uri) {
                                elt.file = json.file;
                                elt.cloudStorageLocation = '';
                            }
                        });
                    } else {
                        // If the file can't play, remove it from the list
                        appFunc.mediaPlaylist.shift();
                        appFunc.prepareNextSong();
                    }
                }
            });
        }
    },
    prepareNextSong: function() {
        var uri = appFunc.ytRelatedVideos && appFunc.ytRelatedVideos[0] ? appFunc.ytRelatedVideos[0].uri : false;
        if(!uri || appFunc.preparingNextSong === true) return;
        appFunc.preparingNextSong = true;
        return $.ajax({
            url: ws_end_point,
            type: 'GET',
            data: {uri: uri, action:'prepareNextSong'},
            dataType: 'jsonp',
        })
        .then(function(json) {
            if(json.success) {
                appFunc.ytRelatedVideos[0].file = json.file;
                appFunc.ytRelatedVideos[0].cloudStorageLocation = '';
                appFunc.partyPlaylist.unshift(appFunc.ytRelatedVideos[0]);
            }
        })
        .always(function() {
            appFunc.ytRelatedVideos.shift();
            appFunc.preparingNextSong = false;
        });
    },
    // Handle station non-stop playlist
    prepareNextMediaPlaylist: function() {
        var pos = appFunc.currentPos + 1;
        if(!appFunc.mediaPlaylist[pos]) return;
        var source = appFunc.mediaPlaylist[pos] ? appFunc.mediaPlaylist[pos].file : false;
        var uri = appFunc.mediaPlaylist[pos].uri;
        var title = appFunc.mediaPlaylist[pos].title;
        console.log('preparing 1...');
        if (!appFunc.isMp3(source)) {
            console.log('preparing 2...');
            return $.ajax({
                url: ws_end_point,
                type: 'GET',
                data: {uri: uri, title: title, action:'prepareNextSong'},
                dataType: 'jsonp',
                error: function(xhr, status, error) {
                    console.log("error");
                },
                success: function(json) {
                    if(json.success) {
                        console.log('file: ',json.file);
                        $.each(appFunc.mediaPlaylist, (idx, elt) => {
                            if(elt.uri == uri) {
                                elt.file = json.file;
                                elt.cloudStorageLocation = '';
                                console.log('replaced: ', uri);
                            }
                        });
                    } else {
                        // If the file can't play, remove it from the list
                        appFunc.mediaPlaylist.splice(pos, 1);
                        appFunc.prepareNextMediaPlaylist();
                    }
                }
            });
        }
    },
    isMp3: function(file) {
        const ext = file.split('.').pop().toLowerCase();
        return ext === 'mp3';
    },
    getItuneChart: function (resp) {
        var country_code = resp.country_code || 'us';
        var limit = resp.limit || 10;
        if (country_code) {
            var flag = '<img class="flag" src="https://jetcamer.com/images/flags/gif/' + country_code.toLocaleLowerCase() + '.gif"/>';
            $('.country_flag').html(flag);

            $("#hystorysearchtitleheader").html(flag + ' Itune Trends');
            window.ituneCallback = function (resp) {
                var eltId = 'carousel-container';
                var content = '';
                var items = resp.feed && resp.feed.entry ? resp.feed.entry : [];
                var videos = items.map(function (video, idx) {
                    var item = {};
                    var title = video["title"].label;
                    var image = video["im:image"][0].label;
                    var file = video["link"][1].attributes.href;
                    item.thumb = item.hdImg = image;
                    item.title = title;
                    item.file = file;
                    item.uri = file.split('\\').pop().split('/').pop();

                    content += appFunc.renderTpl($$('#videoContentTemplate').html(), item);

                    //content += "<a class=\"smGlobalBtnLink\" href=\"javascript:;\" onclick=\"getsearch('" + title + "',1,'1','')\"><span class=\"facebookBt smGlobalBtn\" style=\"background-image:url('" + image + "')\"></span>" + title + "</a>";
                    return item;
                });

                $("#" + eltId).html(content);
            };

            window.playlistCountrySearchTermCallback = function (resp) {
                if(resp && resp.length) {
                    console.log(resp);
                }
            }

            appFunc.loadScript('https://jetcamer.com/ws/json.php?playlistCountrySearchTerm=1&countryCode=' + country_code.toLocaleLowerCase() + '&callback=playlistCountrySearchTermCallback');
            appFunc.loadScript('https://itunes.apple.com/' + country_code.toLocaleLowerCase() + '/rss/topsongs/limit='+limit+'/json?callback=ituneCallback');
        }
    },

    loadScript: function  (src) {
        var script = document.createElement('script');
        script.src = src;
        script.onload = function () {
            //do stuff with the script
        };

        document.head.appendChild(script);
    },

    playLive: function() {
        appFunc.canPlayNext=true;
        doPlayOnMobileHandler({
            source:'http://jetcamer.com:8000/live.mp3?t='+(new Date()).getTime(),
            title: 'Live Music',
            poster: 'http://jetcamerdj.com/img/app_live_thumb.gif?t='+(new Date()).getTime()
        });

        hideLoadingMask();
    },
    isLive: function() {
        var string = videoPlayer.src(),
            expr = /live\.mp3/;
        return expr.test(string);
    },
    checkAppVersion: function() {
        $.ajax({url: ws_end_point, data: {action: 'getDjAppVersion'}, dataType: 'jsonp'})
        .then(function(resp){
            if(parseInt(resp.appVersion) !== appFunc.version) {
                const title = resp.updateText || 'A new version is available. Start upgrade ?';
                swal(title, {
                    buttons: {
                        cancel: "Cancel",
                        continue: {
                            text: 'Continue',
                            value: 'continue',
                        },
                    },
                })
                .then(function(value) {
                    switch (value) {
                        case "continue":
                            window.open(resp.updateLink, '_system');
                            break;
                        default:
                            swal.close();
                    }
                });
            }
        })
    },
};

window.appFunc = appFunc;
module.exports = appFunc;