window.db = null;
var africaVOD_DB = {
    db: null,
    init: function(successCb, errorCb) {
        if(appFunc.isPhonegap()) {
            db = window.sqlitePlugin.openDatabase({name: 'KamerDJ.db', location: 'default'});
        } else {
            var executeSql = function (query, data, onSuccess, onError) {
                var rows = {item: function(idx){}};
                (typeof onSuccess == 'function' ) && onSuccess({}, {rows:rows});
            };

            db = {
                transaction: function (cb) {
                    (typeof cb == 'function' ) && cb({executeSql: executeSql});
                },
            }
        }
        
        //db.transaction(function(transaction) {transaction.executeSql('DROP TABLE playlistMedia;', [], null, null);});

        africaVOD_DB.userPreferences.initUserPreferencesTable(successCb, errorCb);
        africaVOD_DB.playlist.initPlaylistTable(successCb, errorCb);
        africaVOD_DB.playlistMedia.initPlaylistMediaTable(successCb, errorCb);
    },
    onDbError: function(error) {},
    onDbSuccess: function(tx, result) {},
    partyPlaylistPrefName:'partyPlaylist',
    userPreferences: {
        initUserPreferencesTable: function (successCb, errorCb) {
            db.transaction(function (transaction) {
                var onSuccess = typeof successCb == 'function' ? successCb : africaVOD_DB.onDbSuccess;
                var onError = typeof errorCb == 'function' ? errorCb : africaVOD_DB.onDbError;
                transaction.executeSql('CREATE TABLE IF NOT EXISTS userPreferences (id integer primary key, name text, prefValue text)', [], onSuccess, onError);
            });
        },
        saveUserPreference: function (name, prefValue, successCb, errorCb) {
            if(typeof successCb == 'function')  africaVOD_DB.onDbSuccess = successCb;
            if(typeof errorCb == 'function')  africaVOD_DB.onDbError = errorCb;
            db.transaction(function(transaction) {
                transaction.executeSql('SELECT prefValue FROM userPreferences WHERE name=?', [name], function (tx, results) {
                    if(results.rows.length == 1) {
                        africaVOD_DB.userPreferences.updateUserPreference(name, prefValue);
                    } else {
                        africaVOD_DB.userPreferences.insertUserPreference(name, prefValue);
                    }
                }, africaVOD_DB.onDbError);
            });
        },
        insertUserPreference: function(name, prefValue) {
            db.transaction(function (transaction) {
                var executeQuery = "INSERT INTO userPreferences (name, prefValue) VALUES (?,?)";
                transaction.executeSql(executeQuery, [name, prefValue], africaVOD_DB.onDbSuccess, africaVOD_DB.onDbError);
            });
        },
        updateUserPreference: function (name, prefValue) {
            db.transaction(function (transaction) {
                var executeQuery = "UPDATE userPreferences SET prefValue=? WHERE name=?";
                transaction.executeSql(executeQuery, [prefValue, name], africaVOD_DB.onDbSuccess, africaVOD_DB.onDbError);
            });
        },
        getPreference: function(name, successCb, errorCb) {
            db.transaction(function(transaction) {
                var onSuccess = typeof successCb == 'function' ? successCb : africaVOD_DB.onDbSuccess;
                var onError = typeof errorCb == 'function' ? errorCb : africaVOD_DB.onDbError;
                transaction.executeSql('SELECT * FROM userPreferences', [], onSuccess, onError);
            });
        },
        getPreferenceByName: function(name, successCb, errorCb) {
            db.transaction(function(transaction) {
                var onSuccess = typeof successCb == 'function' ? successCb : africaVOD_DB.onDbSuccess;
                var onError = typeof errorCb == 'function' ? errorCb : africaVOD_DB.onDbError;
                transaction.executeSql('SELECT prefValue FROM userPreferences WHERE name=?', [name], onSuccess, onError);
            });
        },
        deletePreferenceByName: function(name, successCb, errorCb) {
            db.transaction(function(transaction) {
                var onSuccess = typeof successCb == 'function' ? successCb : africaVOD_DB.onDbSuccess;
                var onError = typeof errorCb == 'function' ? errorCb : africaVOD_DB.onDbError;
                transaction.executeSql('delete FROM userPreferences WHERE name=?', [name], onSuccess, onError);
            });
        }
    },
    playlist: {
        initPlaylistTable: function (successCb, errorCb) {
            db.transaction(function (transaction) {
                var onSuccess = typeof successCb == 'function' ? successCb : africaVOD_DB.onDbSuccess;
                var onError = typeof errorCb == 'function' ? errorCb : africaVOD_DB.onDbError;
                transaction.executeSql('CREATE TABLE IF NOT EXISTS playlist (id integer primary key, title text, uri text, thumb text)', [], onSuccess, onError);
            });
        },
        savePlaylist: function (name, uri, successCb, errorCb) {
            var onError = typeof errorCb == 'function' ? errorCb : africaVOD_DB.onDbError;
            db.transaction(function(transaction) {
                transaction.executeSql('SELECT id FROM playlist WHERE uri=?', [uri], function (tx, results) {
                    if(results.rows.length > 0) {
                        africaVOD_DB.playlist.updatePlaylist(name, uri, successCb, errorCb);
                    } else {
                        africaVOD_DB.playlist.insertPlaylist(name, uri, successCb, errorCb);
                    }
                }, onError);
            });
        },
        insertPlaylist: function(name, uri, successCb, errorCb) {
            var onSuccess = typeof successCb == 'function' ? successCb : africaVOD_DB.onDbSuccess;
            var onError = typeof errorCb == 'function' ? errorCb : africaVOD_DB.onDbError;
            db.transaction(function (transaction) {
                var executeQuery = "INSERT INTO playlist (title, uri) VALUES (?,?)";
                transaction.executeSql(executeQuery, [name, uri], onSuccess, onError);
            });
        },
        updatePlaylist: function (name, uri, successCb, errorCb) {
            var onSuccess = typeof successCb == 'function' ? successCb : africaVOD_DB.onDbSuccess;
            var onError = typeof errorCb == 'function' ? errorCb : africaVOD_DB.onDbError;
            db.transaction(function (transaction) {
                var executeQuery = "UPDATE playlist SET title=? WHERE uri=?";
                transaction.executeSql(executeQuery, [name, uri], onSuccess, onError);
            });
        },
        getPlaylist: function(successCb, errorCb) {
            db.transaction(function(transaction) {
                var onSuccess = typeof successCb == 'function' ? successCb : africaVOD_DB.onDbSuccess;
                var onError = typeof errorCb == 'function' ? errorCb : africaVOD_DB.onDbError;
                transaction.executeSql('SELECT * FROM playlist order by id desc', [], onSuccess, onError);
            });
        },
        deletePlaylist: function (uri, successCb, errorCb) {
            var onSuccess = typeof successCb == 'function' ? successCb : africaVOD_DB.onDbSuccess;
            var onError = typeof errorCb == 'function' ? errorCb : africaVOD_DB.onDbError;
            db.transaction(function (transaction) {
                var executeQuery = "DELETE from playlist WHERE uri=?";
                transaction.executeSql(executeQuery, [uri], onSuccess, onError);
            });
        },
    },
    playlistMedia: {
        initPlaylistMediaTable: function (successCb, errorCb) {
            db.transaction(function (transaction) {
                var onSuccess = typeof successCb == 'function' ? successCb : africaVOD_DB.onDbSuccess;
                var onError = typeof errorCb == 'function' ? errorCb : africaVOD_DB.onDbError;
                transaction.executeSql('CREATE TABLE IF NOT EXISTS playlistMedia (id integer primary key, title text, uri text, file text, thumb text, genre text, cloudStorageLocation text, playlistUri text)', [], onSuccess, onError);
            });
        },
        savePlaylistMedia: function (playlistUri, mediaArray, successCb, errorCb) {
            db.transaction(function(transaction) {
                transaction.executeSql('SELECT id FROM playlistMedia WHERE uri=?', [uri], function (tx, results) {
                    if(results.rows.length > 0) {
                        africaVOD_DB.playlistMedia.updatePlaylistMedia(playlistUri, mediaArray, successCb, errorCb);
                    } else {
                        africaVOD_DB.playlistMedia.insertPlaylistMedia(playlistUri, mediaArray, successCb, errorCb);
                    }
                }, africaVOD_DB.onDbError);
            });
        },
        insertPlaylistMedia: function(playlistUri, medias, successCb, errorCb) {
            var onSuccess = typeof successCb == 'function' ? successCb : africaVOD_DB.onDbSuccess;
            var onError = typeof errorCb == 'function' ? errorCb : africaVOD_DB.onDbError;
            var executeQuery = medias.map((elt) => { return ['INSERT INTO playlistMedia (title, uri, file, thumb, cloudStorageLocation, playlistUri, genre) VALUES (?,?,?,?,?,?,?)', [elt.title, elt.uri, elt.file, elt.thumb, elt.cloudStorageLocation, playlistUri, elt.genre]]; });
            db.sqlBatch(executeQuery, onSuccess, onError);
        },
        updatePlaylistMedia: function(playlistUri, medias, successCb, errorCb) {
            var onError = typeof errorCb == 'function' ? errorCb : africaVOD_DB.onDbError;
            africaVOD_DB.playlistMedia.deletePlaylistMedia(playlistUri, function() {
                africaVOD_DB.playlistMedia.insertPlaylistMedia(playlistUri, medias, successCb, errorCb);
            }, errorCb);
        },
        getPlaylistMedia: function(playlistUri, successCb, errorCb) {
            console.log('ssfsfsfsf')
            db.transaction(function(transaction) {
                var onSuccess = typeof successCb == 'function' ? successCb : africaVOD_DB.onDbSuccess;
                var onError = typeof errorCb == 'function' ? errorCb : africaVOD_DB.onDbError;
                var executeQuery = 'SELECT * FROM playlistMedia where playlistUri = ? order by id desc';
                var executeParams = [playlistUri];
                if(playlistUri == 'all') {
                    executeQuery = 'SELECT * FROM playlistMedia group by playlistUri order by id desc';
                    executeParams = [];
                }
                transaction.executeSql(executeQuery, executeParams, onSuccess, onError);
            });
        },
        deletePlaylistMedia: function (playlistUri, successCb, errorCb) {
            var onSuccess = typeof successCb == 'function' ? successCb : africaVOD_DB.onDbSuccess;
            var onError = typeof errorCb == 'function' ? errorCb : africaVOD_DB.onDbError;
            db.transaction(function (transaction) {
                var executeQuery = "DELETE from playlistMedia WHERE playlistUri=?";
                transaction.executeSql(executeQuery, [playlistUri], onSuccess, onError);
            });
        },
        deletePlaylistMediaItemById: function (mediaId, successCb, errorCb) {
            var onSuccess = typeof successCb == 'function' ? successCb : africaVOD_DB.onDbSuccess;
            var onError = typeof errorCb == 'function' ? errorCb : africaVOD_DB.onDbError;
            db.transaction(function (transaction) {
                var executeQuery = "DELETE from playlistMedia WHERE id=?";
                transaction.executeSql(executeQuery, [mediaId], onSuccess, onError);
            });
        },
    }
};

module.exports = africaVOD_DB;