(function($) {
    'use strict'

/**
 * Attach click handlers to videos images and play the video
 * in a modal on click.
 * 
 * @type {Object}
 */
ko.bindingHandlers.playVideos = {
    containerID:"videoPlayerContainer",
    mediaPath:window.out_dir,
    videoFile:"",
    currentVideo:"",
    init: function (element, valueAccessor, allBindingsAccessor, context) {
        var _that = this;
        return false;
    },

    doPlay: function(source, poster, title, uri, playlist){
			var _that = this;
			var isMobile = !isDesktop(); //!$("#" + _that.containerID).is(":visible");
			var ext = source.substr(source.lastIndexOf('.')+1);
			var isVideo = ext == "mp4";
			var isAudio = ext == "mp3";
			var isGame  = ext == "html";
			var isEbook = ext == "pdf";
			var isPhoto = (/\.(gif|jpg|jpeg|tiff|png)$/i).test(source);
			var file = _that.mediaPath + source
			var title = title !== undefined ? title : "";

			_that.fileName = source;
			_that.currentVideo = source;
			_that.videoUri = uri;
			_that.setNextVideo();
			
			if(typeof window.doPlayOnMobileHandler === "function") {
				window.doPlayOnMobileHandler.call(this, {source:source, poster:poster, title:title});
				console.log('nacos------------');
				return false;
			}
			
			if(isGame) {
					window.location.href = source;
			}else if(isPhoto) {
					_that.showPhoto(source);
			}else if(isEbook) {
					webViewerInitialized(source)
			} else if(isAudio) {

					//only show the cassette UI on large screen
					if(!isMobile) {
							audioCassetManager(window);
					}
					
					$.fullwidthAudioPlayer.clear();
					$.fullwidthAudioPlayer.addTrack(file, title);
					$.fullwidthAudioPlayer.play();
					$.fullwidthAudioPlayer.currentSongTitle = title;

					//open the audio playler with animation
					$.fullwidthAudioPlayer.setPlayerPosition('open', true);

			} else {

					//pause the audio player
					try{
							$.fullwidthAudioPlayer.pause();
							$.fullwidthAudioPlayer.setPlayerPosition('close', true);
					}catch(e){}

					var _that = this;
					if(isMobile) {
							_that.doPlayOnMobile(file, poster);
					} else {
							_that.doPlayOnDesktop(file, poster);
					}
			}

			//close header overlay
			$(".cd-search-trigger.search-is-visible").trigger("click");
			$(".cd-nav-trigger.nav-is-visible").trigger("click")
			$(".main-menu.selected").trigger("click");
    },

    doPlayOnDesktop: function(source, poster){
				if(typeof window.doPlayOnDesktopHandler === "function") {
					window.doPlayOnDesktopHandler.call(this, {source:source, poster:poster});
					return false;
				}
				
        var _that = this;
        var videoHeight = $(window).height() - 60;
        var $el = $("#" + _that.containerID);
        var $videoElt = $el.find("video");
        var videoFile = "";

        try{
            //_that.player.dispose();
        }catch(e){
            console.log(e);
        }

        if($videoElt.length == 0) {
            //$el.html('<video id="vidjs" class="video-js vjs-default-skin" controls preload="auto" width="100%" height="' + videoHeight + '"> </video>');
        }

        $('html,body').animate({
            scrollTop: 0,
            scrollLeft: 0
        }, 800, function(){
            $('html,body').clearQueue();
        });

        
        /*
        //set up either to play from youtube or mp4 file
        if (source.indexOf('youtube') != -1) {
            _that.player = videojs('vidjs', { "techOrder": ["youtube"]}).src(source).play();
        }
        else {
             _that.player = videojs('vidjs', { "techOrder": ["html5", "flash"]}).src(source).play();
        }

        videojs("vidjs").ready(function(){
            this.on("canplay", function(){ 
                
            });

            this.on("ended", function(){ 
                //need to destroy the previous instance first
                try{
                    _that.player.dispose();
                }catch(e){
                    console.log(e);
                }
                
                _that.doPlay(_that.videoFile, poster);
            });
        });
        */

        if(window.shiftKeyDown === true){
            alert("on tv");
            return;
        }

        

        $("#videoPlayerContainer").height(videoHeight);

        var m3uFile = "/mediatheque/playlist/" + _that.videoUri + "/file.rss";

        console.log("Nacos 1: " + m3uFile);

        _that.rtmpPlayer = $f("videoPlayerContainer", "jet_files/flow_player_rtmp/flowplayer-3.2.16.swf", {
            clip: {
                scaling: 'fit',
                provider: 'hddn',
                autoPlay: true,
                autoBuffering: true
            },

            playlist: m3uFile,
         
            plugins: {
                hddn: {
                    url: "jet_files/flow_player_rtmp/flowplayer.rtmp-3.2.12.swf",
         
                    // netConnectionUrl defines where the streams are found
                    netConnectionUrl: 'rtmp://' + location.hostname + ':1935/vod2'
                }
            },
            canvas: {
                backgroundGradient: 'none'
            }
        });

        _that.rtmpPlayer.play();
        
        console.log("Nacos 1: " + _that.fileName);
    },

    doPlayOnMobile: function(source, poster){
				if(typeof window.doPlayOnMobileHandler === "function") {
					window.doPlayOnMobileHandler.call(this, {source:source, poster:poster});
					return false;
				}
				
        var _that = this;
        var videoFile;
        var modal = $('#vid-modal .modal-body'),
            videoHeight = $(window).height() - 60;
            
         modal.html('');

        //dispose of video.js video player on bootstrap modal close
        $('#vid-modal').on('hidden.bs.modal', function (e) {
            if (vars.trailersPlayer == 'default') {
                modal.html('');
            } else {
                videojs('vidjs').dispose();
            }
        });

        //if there's no source we'll just open new window
        //with given url
        if (vars.trailersPlayer == 'default') {
            modal.html('<iframe class="embed-responsive-item" src="'
                +source+'?autoplay=1&iv_load_policy=3&modestbranding=1" width="100%" height="'+videoHeight+'" wmode="opaque" allowfullscreen="true"></iframe>');
        } else {
            //create player element
            modal.html('<video id="vidjs" class="video-js vjs-default-skin" controls preload="auto" width="100%" height="'+videoHeight+'" poster="'+poster+'"> </video>');
            

            //set up either to play from youtube or mp4 file
            if (source.indexOf('youtube') != -1) {
                videojs('vidjs', { "techOrder": ["youtube"]}).src(source).play();
            }
            else {
                videojs('vidjs', { "techOrder": ["html5", "flash"]}).src(source).play();
            }

            videojs("vidjs").ready(function(){
                this.on("canplay", function(){ 

                });

                this.on("ended", function(){ 
                    _that.doPlay(_that.videoFile, poster);
                });
            });  
        }

        $('#vid-modal').modal();
    },

    doPlayAudio: function(){
        var $el = $("#" + this.containerID);
        $el.css({"background-image":"url('./img/audio_player_bg_1600.jpg')"});
        window.setTimeout(function() {
            // transition hack
            $el.html($(".casset-tape-ui").html());
            //document.getElementById('tape-loader').className = 'visible';
        }, 1);
    },

    showPhoto: function(source){
        var _that = this;
        var $el = $("#" + _that.containerID);
        // simple text watermark
        $.fancybox.showLoading();
        watermark([_that.mediaPath + source])
          .image(watermark.text.center('JetCamer Photo', '50px serif', '#fff', 0.7))
          .then(function (img) {
            $.fancybox({ 
              'href': img.src,
              'type' : 'image',
              afterShow:function(){
                $.fancybox.hideLoading();
              }
            }); 
        });
    },

    setNextVideo: function() {
        var _that = this;
        window.nacos = this;

        //if(_that.currentVideo == _that.videoFile) return;

        var url = window.baseUrl;
        var data = "action=buyMedia";
        $.ajax({
            url: url,
            dataType:"jsonp",
            data: data,
            success: function(o){
                var file = o.nextVideo[0].file;
                //var file = "http://www.youtube.com/v/" + o.nextVideo[0].videoUri;
                _that.videoFile = file;
            },

            error:function(e){
                console.log(e);
            }
        });
    }
};

})(jQuery);