require('./video.less');
require('./js/jet_files/sweetalert.less');
require("./css/kitchen-sink.less");
require("./css/touchcarousel.less");
require("./js/jquery.swipebox.js");
require("./js/jet_files/main.js");
window.jetLazyLoad = require('../utils/JetLazyLoad');
let md5 = require('js-md5');

import {Howl, Howler} from 'howler';

import swal from 'sweetalert';
window.swal = swal;

var enableInlineVideo = require('iphone-inline-video');

const appFunc = require('../utils/appFunc');
const template = `
	<div class="navbar">
		<div class="navbar-inner">
			<div class="right">
				<a href="#" class="tab-link search"data-genre="search">
					<i class="fa fa-search" style="color:white;"></i>
				</a>
			</div>
			<div class="left" style="display: flex; height: 100%;">
				<a href="#" onclick="appFunc.showHomePage()" style="display:flex; align-items: center; position:relative; margin-left: 0px;">
					<img src="res/logo_jet_square.png?v=1" style="border-radius: 35px; height:35px; width:35px;">
					<span style="color:#fff; margin-left:10px; text-transform: uppercase;">
						<span>${appFunc.bgModeNotificationConfig.title}</span>
					</span>
				</a>
			</div>
		</div>
	</div>

	<div class="page-content infinite-scroll"  data-distance="50">
		<div id="videoPlayerContainer" class="content-block-title" style="background:#000; margin:0; max-height:40%; overflow:hidden; padding-top:0;">
			<div class="titlebar">
				<h4 class="titlebarText">
					<span class="titlebarTextLabel"></span>
					<span style="display: none;align-items: center;justify-content: center;">
						<img src="res/playlist-512.png" style="height: 1em;">
						<span style="text-decoration: none;">My Offline Library</span>
					</span>
				</h4>
			</div>
			<!-- Swiper -->
			<div id='videoSwipe' style='margin:0 auto' class="swipe swiper-container">
				<div class="swiper-wrapper swipe-wrap"></div>
				<div class="swiper-pagination"></div>
			</div>
		</div>
		
		<div id="carousel-container"></div>
		
		<div class="main-content" style="margin-left:0; margin-right:0;"></div>
		<div class="latest-content" style="margin-left:0; margin-right:0;">
			<div id="recentMediaContainer">
				<h2 class="hdrTitle"></h2>
				<div class="mediaContainer"></div>
			</div>
		</div>
		<div class="popular-content" style="margin-left:0; margin-right:0;">
			<div id="popularMediaContainer">
				<h2 class="hdrTitle"></h2>
				<div class="mediaContainer"></div>
			</div>
		</div>
	</div>`;
		
var videoView = {
    init: function(initLoad){
			window.videoScriptLoaded = true;
			videoView.bindEvents();
			//load video when the main app loads if offline mode
			if(initLoad === true) {
				videoView.render();
			}

			//*
			appFunc.headerTxt = `
				<span class="headerLabel" onclick="appFunc.showHomePage()" style="text-decoration: none;">
					<i class="fa fa-home"></i>Home
				</span>
				<span class="home-tab-link headerLabel" data-title="My playlist medias" data-station="1" data-genre="audio" style="text-decoration: none;">
					<i class="fa fa-music"></i>Station
				</span>
				<span class="homeLibraryMoreLink headerLabel" data-title="My playlist medias" data-uri="all" style="text-decoration: none;">
					<i class="fa fa-user"></i>Account
				</span>
			`;
			//*/

			/*
			appFunc.headerTxt = `
					<span class="liveLink headerLabel" style="text-decoration: none;">
						<img src="res/live.gif" style="height: 1em; margin-right:3px;">
						Live
					</span>
					<span class="home-tab-link headerLabel" data-title="My playlist medias" data-station="1" data-genre="audio" style="text-decoration: none;">
						<img src="res/playlist-512.png" style="height: 1em;">
						Station
					</span>
					<span class="homeLibraryMoreLink headerLabel" data-title="My playlist medias" data-uri="all" style="text-decoration: none;">
						<i class="fa fa-user" style="margin-right: 3px;"></i>
						Account <span class="libraryCount"></span>
					</span>
				`;
			//*/

			$('.titlebarTextLabel').html(appFunc.headerTxt);
    },
    render: function(){
			window.myApp = hiApp;
			myApp.videoView = 0;
			if(videoView.slideStarted !== true) videoView.setSlides();
			
			//don't reload the same page
			if($$('#videoView .page-content')[0]) return;
			
			//will be hidden after ajax
			showLoadingMask();

			var output = appFunc.renderTpl(template, {domain: window.domain, protocol: window.protocol});
			
			$$('#videoView .page[data-page="index"]').html(output);
			


        //set the flag for script loaded
        window.videoScriptLoaded = true;

        var params = appFunc.urlParams(window.location.href);
        var mediaUri = params.uri;
        if(mediaUri) {
            hideLoadingMask();
            var $playerPopup = $('.video-player-popup');
            var playCurrentVideo = function() {
                appFunc.playFileFromPath({ mediaUri: mediaUri });
                var ptm = setTimeout(function(){
                    if($playerPopup.is(':visible')) {
                        hideLoadingMask();
                        clearTimeout(ptm);
                        return;
                    } else {
                        playCurrentVideo();
                    }
                }, 500);
            };

            playCurrentVideo();
        }


        //attempt to hide the mask if content also loaded
        videoView.hideVideoLoadingMask();

		initListners();
    },
    bindEvents: function(){
			var bindings = [{
					element: '#videoView',
					event: 'show',
					handler: videoView.render
			},
			{
				element: '.media-action-div',
				selector: '.media-action-link',
				event: 'click',
				handler: function () {
					appFunc.showMediaAction();
				}
			}];

			appFunc.bindEvents(bindings);
		},
		hideVideoLoadingMask: function() {
			if(window.videoScriptLoaded === true && window.videoContentLoaded === true) {
				window.videoLoaded = true;
				window.hideLoadingMask();
			}
		},
		setSlides: function(thumbs) {
			var initCountry = '';
			var width = $(window).width();
			var height = (width * 300) / 700;

			// Slider placeholder content
			$("#videoSwipe .swipe-wrap").html('');

            window.videoSwipe && window.videoSwipe.destroy && window.videoSwipe.destroy();
			window.videoSwipe = hiApp.swiper('.swiper-container', {
				speed: 400,
				spaceBetween: 100,
				autoplay: 3000,
				onClick: function(swiper, event) {
					let target = swiper.clickedSlide;
					let link = $(target).data("link");
					if(link) window.open(link);
				},
				onSlideChangeStart: function(swiper) {
					let target = swiper.clickedSlide;
					let title = $(target).data("title");
					if(title) $(target).find('.titlebar').html(title);
				}
			});

            var html = `<div class="swiper-slide"><img src="http://jetcamerdj.com/img/mobile_app_banner.jpg?v=${(new Date()).getTime()}" style="width:100%; position:absolute; top:0;"/></div>`;
            if(typeof videoSwipe.appendSlide == 'function') videoSwipe.appendSlide([html]);
            $('.swiper-slide').css('height', height);
		}
};

window.isDesktop = function(){
	return false;
}

function setContentLoadedState() {
    videoView.setSlides();

    //set the flag for content loaded
    window.videoContentLoaded = true;
    //attempt to hide the mask if scripts also loaded
    videoView.hideVideoLoadingMask();

    $(".page-content.infinite-scroll").scrollTop(0);
}

function initListners() {
    setContentLoadedState();
    appFunc.showHomePage(2);
    appFunc.africaVOD_DB.init();

    appFunc.checkAppVersion();

    // Set initial playlist to be used when user skip live
    $.ajax({url: ws_end_point, data: {action:'getJetRelatedVideos', uri:'fakeUri'}, type: 'GET', dataType: 'jsonp'})
	.then(function (response) {
		appFunc.mediaPlaylist = response;
	});

	// Loading trigger
	let loading = false;
	window.loadData = function loadData(showLoader, dataType) {
		if(showLoader) showLoadingMask();

		let params = "dataType=json&action=getGenreMedia&t=" + (new Date()).getTime();
		$.ajax({
				url: ws_end_point + '?' + params,
				type: 'GET',
				dataType: 'jsonp',
				error: function(xhr, status, error) {
					console.log("error" + error);
                    appFunc.checkNetworkStatus();
				},
				success: function(json) {
					myApp.videoView++;
					var carosselHtml = getCarousel(json);
					$$("#carousel-container").html(carosselHtml);
					setContentLoadedState();
				},
				fail: function(e){
					appFunc.checkNetworkStatus();
				}
		}).always(function(){
            setContentLoadedState();
        });
	}

	var delay = (function(){
		var timer = 0;
		return function(callback, ms){
			clearTimeout (timer);
			timer = setTimeout(callback, ms);
		};
	})();
	
	var doSearch = function(search){
		var params = "jetvideos&isJetBox=1&countries=" + (window.countries || '') + "&languages=" + (window.languages || '') + "&type=video&playlistJosn="+escape(search)+"&subType=&subTypeValue=&page=" + myApp.videoView + "&t=" + (new Date()).getTime();
		var $container = $(".search-results");
		$container.html("");
		
		showLoadingMask();
		$.ajax({
			url: ws_end_point + '?' + params,
			type: 'GET',
			dataType: 'jsonp',
			error: function(xhr, status, error) {
				hideLoadingMask();
				swal("error");
                appFunc.checkNetworkStatus();
			},
            fail: function(xhr, status, error) {
                hideLoadingMask();
                swal("error");
                appFunc.checkNetworkStatus();
            },
			success: function(json) {
				var html = getHtml(json);
				$container.html(html);
				
			},
			complete: function(json) {
				hideLoadingMask();
			}
		}).always(function(){
			hideLoadingMask();
		});
	};

	$$(".tab-link[data-genre='search']").on('click', function (e) {
		appFunc.browseYtVideo();
	});
	
	$$('.close-tab-dialog').on('click', function (e) {
		$("#popularMediaContainer").appendTo(".popular-content");
		myApp.closeModal();
		myApp.tabIsOpen = false;
	});


    $(document).delegate('*', 'click', function() {
    	if(window.initalizing) return;
    	if(!appFunc.eventScope) {
    		window.initalizing = true;
            console.log('play scope set...');
            appFunc.eventScope = this;

            var videoTag = '<audio id="vidjs" class="video-js vjs-default-skin" playsinline controls style="height:100% !important; width:100% !important;" preload="auto"> </audio>';
            $('.video-player-popup').find('.page-content').html(videoTag);
            var videoElt = $('#vidjs')[0];
            enableInlineVideo(videoElt);
            let videoPlayer = videojs(videoElt, { "techOrder": ["html5"]}).src(window.silent_audio);

            //!appFunc.isPhonegap() && videoPlayer.play();

            window.videoPlayer = videoPlayer;
		}
	});

	$(document).delegate('.media-action-link', 'click', appFunc.showMediaAction);
    $(document).delegate('.media-share-link', 'click', appFunc.share);
    $(document).delegate('.media-download-link', 'click', downloadMediaLink);
    $(document).delegate('.queueLink', 'click', appFunc.refreshQueue.bind(this, {isDirty:false, showList: true, isQueue: true}));
    $(document).delegate('.chartLink', 'click', appFunc.getItuneChart.bind(this, {country_code:'fr', limit:50}));
    $(document).delegate('.playlistLink', 'click', appFunc.showUserPlaylist);
    $(document).delegate('.createNewPaylist', 'click', appFunc.createPlaylist);
    $(document).delegate('.deletePlaylistLink', 'click', appFunc.deletePlaylist);
    $(document).delegate('.libraryMoreLink', 'click', appFunc.showLibraryMoreOptions);
    //$(document).delegate('.add-media-link', 'click', appFunc.browseSuggestedMedia);
    $(document).delegate('.add-media-link', 'click', appFunc.browseSuggestedMedia.bind(this, 'youtube-popup'));
    $(document).delegate('.closeLoadingSpinner', 'click', hiApp.hidePreloader);
    $(document).delegate('.liveLink', 'click', appFunc.playLive);
    $(document).delegate('.homeLibraryMoreLink', 'click', (e) => {
        if(!Phone2Phone.checkAuth()) {
			return hiApp.loginScreen();
		}

    	appFunc.showPlaylistMedia(e);
    });

    $(document).delegate("#jslidertrasp1", "click", function(e){
        var perc = e.offsetX/ $(this).width();
        videoPlayer.currentTime(perc * videoPlayer.duration());
    });

    $(document).delegate('.youtube .searchbar-input input', 'keyup', function () {
        var search = $$(this).val() || '';
        return appFunc.delay(appFunc.browseYtVideo.bind(appFunc, {search: search}), 1000);
    });

    $(document).delegate('.refresSuggestionsBtn', 'click', function(e) {
    	appFunc.partyPlaylist = appFunc.queueMediaSuggestions;
    	appFunc.refreshQueue();
        hiApp.closeModal('[data-popup="suggestions-popup"]');
    	videoPlayer.muted(false);
    	appFunc.playNext(); // might use doMobile play here for auto play handling
    	/*
        showLoadingMask();
        appFunc.getQueueSuggestions()
		.always(hideLoadingMask);
		*/
    });

    $(document).delegate('.playlist-media-download-link', 'click', function(e) {
        e.preventDefault();
    	const elt = e.currentTarget;
        downloadMediaLink(elt);
	});

    $(document).delegate('.mediaActionLink.deleteMedia', 'click', function(e){
        let target = e.currentTarget;

        swal("Permanently delete this item ?", {
            buttons: {
                cancel: "Cancel",
                delete: "Delete",
            },
        })
		.then(function(value) {
			var idx = $($(target).parents('.listInfo')[0]).data('idx');
			switch (value) {
				case "delete":
					var isQueue = $('.isQueue').is(':visible');
					if(isQueue) {
						appFunc.partyPlaylist.splice(idx, 1);
						appFunc.refreshQueue({isQueue: true});
					} else if(appFunc.selectedPartyPlaylist) {
                        const mediaObj = appFunc.currentPlayistItems[idx];
                        const mediaId = mediaObj.id;
                        const mid = Phone2Phone.getCookie('memberID');
                        $.ajax({url:jet_ws_end_point, dataType:'jsonp', data:{ mid: mid, deleteVideoPlaylistMedia: mediaId, playlistUri: appFunc.selectedPartyPlaylist }}).then(function (data) {
                            appFunc.getPlaylistMediaByUri(appFunc.selectedPartyPlaylist, false, function(items) {
                                if(items.length == 0) {
                                    //appFunc.removeMediaFromDisk(mediaObj);
                                }
                            });
                        }, function() {
                            swal("Oops. Error!", "", "error");
                        });
					}
					break;

				case "cancel":
					swal.close();
					break;

				default:
					swal.close();
			}
		});
    });

	$('form.media').submit(function(e) {
		e.preventDefault();
		let elt = e.currentTarget;
		var search = $(elt).find('.searchbar-input input').val();
		if(!$.trim(search)) return;
		doSearch(search);
	});

    $(document).delegate('.station-tab-link', 'click', function (e) {
        var el = e.currentTarget || e.target;
        var genre = $(el).attr("data-genre");
        $('.stationContainer').html(genre);
    });

    $(document).delegate('.home-tab-link', 'click', function (e) {
        var el =  e.currentTarget || e.target;
        var genre = $(el).data("genre");
        var isStation = parseInt($(el).data("station"), 10) === 1;
        var $container = $("#carousel-container");
        if(genre == 'home'){
            appFunc.showHomePage(1);
        	return;
		}
        appFunc.currentGenre = genre;
        $('.genreTitle').html(genre.toUpperCase());
        setGenreCategories(genre, function(json){
            var json = eval(json);
            //var html = '<div class="card"><div class="card-header">New Releases:</div>';
            let header = ''; //!isStation ? '' : `<div class="playlistHeadingContent"><div class="button_style_5"><a href="javascript:;" class="but2 playAllBtn home-tab-link" data-station='1' data-genre="stationGenre"><span class="title">Genres</span><span class="fa fa-play"></span></a><a href="javascript:;" class="but2 home-tab-link" data-station='1' data-genre="stationCountry"><span class="title">Countries</span><span class="extra" style="display:none;"><input type="text"></span><span class="fa fa-globe"></span></a><a href="javascript:;" class="but2 home-tab-link" data-station='1' data-genre="stationArtist"><span class="title">Artists</span><span class="fa fa-users"></span></a></div></div>`;
            $container.html(`${header}<div class="stationContainer"></div>`);
            let html = '';
            $$.each(json, function(idx, el){
                var that = el;
                var uri = '';
                var actionTxt = 'Browse';
                var autoPlayAttr = '';
                var playFaIcon = '';
                var actionFaIcon = 'fa fa-list';
				if(isStation) {
                    actionTxt = 'Music station';
                    autoPlayAttr = 'autoplay';
                    playFaIcon = 'fa fa-play';
                    actionFaIcon = 'fa fa-music';
                }

				html += `
                	<div class="card">
					  <div class="card-footer"> 
					    <span class="playlistCardLeft" data-genre="${that.playlist}">
					  		<div class="item-media cardPlayLink" ${autoPlayAttr} data-genre="${that.playlist}">
					  			<img data-src="${that.thumb}" class="jet-lazy-load"/>
					  		</div>
							<div class="item-inner">
							  <div class="item-title-row">
							    <div class="item-title">${that.title}</div>
							  </div>
							  <div class="item-subtitle cardPlayLink" data-genre="${that.playlist}"><i class="fa fa-list"></i> Browse station</div>
							</div>
					  	</span>
					  	<span class="cardPlayLink" ${autoPlayAttr} data-genre="${that.playlist}"><i class="${playFaIcon}"></i></span>
					  </div>
					</div>
				`;
            });

            jetLazyLoad.init($container[0]);
            $container.find('.stationContainer').html(html);
            $(".page-content.infinite-scroll").scrollTop(0);

        })
    });

	$(document).delegate('.item-link.genre, .genre-more', 'click', function (e) {
		var el =  e.currentTarget || e.target;
		var genre = $(el).attr("data-genre");
		$('.genreTitle').html(genre.toUpperCase());
		setGenreCategories(genre, function(json){
            var json = eval(json);
            var html = '';
            $$.each(json, function(idx, el){
                var that = el;
                var uri = '';

                html += '<li><a href="#" class="item-link category-more" data-genre="'+that.playlist+'"><div class="item-content"><div class="item-inner"><div class="item-title">'+$('<div/>').append(that.title).html()+'</div></div></div></a></li>';

            });

            $$(".menuContainer").html(html);

			//back to category listing
			if(rightView.history && rightView.history.length > 1) {
				rightView.back();
			}
			myApp.openPanel("right");
		})
	});

    $(document).delegate('.cardPlayLink, .category-more', 'click', setCategoryMedia);
	
	$(document).delegate('.playVideo', 'click', function (e) {
        appFunc.eventScope = this;

		e.preventDefault();
		var _this = $(this).parents(".listInfo");
        videoPlayer.muted(false);
		handlePlayClick(_this);
	});

	// Important: this should not call handlePlayClick to avoid changing current playlist
    $(document).delegate('.playLibraryMedia', 'click', function (e) {
        appFunc.eventScope = this;

        videoPlayer.muted(false);
        e.preventDefault();
        var _this = $(this).parents(".listInfo")[0];
        var pos = $(_this).data('idx');
        var file = $(_this).data('file');
        var uri = $(_this).data('uri');
        var title = $(_this).data('title');
        var thumb = $(_this).data('thumb');
        appFunc.canPlayNext = true;
        doPlayOnMobileHandler({source: file, uri:uri, title: title, thumb: thumb});
    });


    $(document).delegate('.swipebox', 'click', function (e) {
        videoPlayer.muted(false);
		e.preventDefault();
		handlePlayClick(this);
	});

	$$('.tv-icon').on('click', function (e) {
		if(!myApp.tvOn){
			swal("TV BOX NOT FOUND !");
		}else{
			swal($("<span>&#10004; TV BOX CONNECTED</span>").html());
		}
	});

    $(document).delegate('.moveItemUp','click', function(){
        appFunc.moveItemUp(this);
    });

    $(document).delegate('.moveItemDown','click', function(){
        appFunc.moveItemDown(this);
    });

    $(document).delegate('.moveItemBottom','click', function(){
        appFunc.moveItemBottom(this);
    });

    $(document).delegate('.moveItemTop','click', function(){
        appFunc.moveItemTop(this);
    });
}

function handlePlayClick(_this) {
    appFunc.canPlayNext = true;
    var file = $(_this).data('file');
    var thumb = $(_this).data('thumb');
	var uri = $(_this).data("uri");
    var title = $(_this).data("title");
	if(file.indexOf('youtube') != -1) {
        doPlayOnMobileHandler({source: file, uri:uri, title: title, thumb: thumb});
	} else {
        appFunc.playFileFromPath({ mediaUri: uri });
	}

    $.ajax({
        url: ws_end_point,
        data: {action:'getYtRelatedVideos', uri:uri},
        type: 'GET',
        dataType: 'jsonp',
    })
	.then(function (response) {
		if(response && response.items) {
            appFunc.ytRelatedVideos = response.items.map(function (video, idx) {
                var item = {};
                item.uri = video.id.videoId;
                item.id = video.id.videoId;
                item.hdImg = video.snippet.thumbnails.default.url;
                item.thumb = video.snippet.thumbnails.default.url;
                item.title = video.snippet.title;
                item.file = "http://www.youtube.com/watch?v=" + video.id.videoId;
                return item;
            });
		}

        // Important as the next song will only be avaible when the party playlist as changed.
        appFunc.prepareNextSong();
	});
}

function getHtml(json) {
	json = eval(json);
	appFunc.loadMediaList({mediaArray:json});
	return;
}

window.genreListItem = function(data) {
    return '<li><a href="#" class="item-link genre" data-genre="'+data.uri+'"><div class="item-content"><div class="item-inner"><div class="item-title">'+data.title+'</div></div></div></a></li>';
}

function getCarousel(json) {
	var html = '';
	var genreMenu = '';
	var t = (new Date()).getTime();
	json = eval(json);


	for(var i=0; i<json.length; i++){
		var data = json[i];
		if (data.media.length < 5) continue;
		
			html += '<div id="carousel-image-and-text_'+i+'" class="touchcarousel '+data.genre_uri+' grey-blue carousel-image-and-text"><div class="genre-header"><a href="#" class="genre-title">Genre: '+data.genre_name+'</a><a href="#" class="genre-more" data-genre="' + data.genre_name + '">See more</a></div><ul class="touchcarousel-container" data-genre="'+data.genre_name+'" style="border-bottom:solid thin rgba(61, 76, 84, 0.8); display:table;">';
			$$.each(data.media, function(idx, el){
				var that = el;
				var uri = '';
				that.youtube = that.youtube || '';

				html += '<li class="touchcarousel-item swipebox" data-uri="'+that.uri+'" data-youtube="'+that.youtube+'" data-title="'+that.title+'" style ="padding-right:5px;"><a class="item-block -container" href="#" ><img class=""  src="'+thumbDir+that.image+'"/><p class="touchcarousel-title" style="color:#ffffff; height:60px; overflow-y:hidden; display:inline-block;">'+$("<div/>").append(that.title).text()+'</p></a></li>';
				
			});
			
			genreMenu += genreListItem({uri: data.genre_uri, title: data.genre_name});
			
			html += '</ul></div>';
	}
	
	$$(".genreContainer").html(genreMenu);
	
	return html;
}

function loadCategoryMedia(category, isPlayAll){
	if(!category) return;
	var params = "jetvideos&isJetBox=1&countries=" + (window.countries || '') + "&languages=" + (window.languages || '') + "&type=video&playlistJosn=&subType=playlist&subTypeValue=" + category + "&page=" + myApp.videoView + "&t=" + (new Date()).getTime();
	
	showLoadingMask();
	$.ajax({
		url: ws_end_point + '?' + params,
		type: 'GET',
		dataType: 'jsonp',
		error: function(xhr, status, error) {
			console.log("error");
            appFunc.checkNetworkStatus();
		},
		success: function(json) {
			var html = '';
			json = eval(json);
			
			appFunc.loadMediaList({mediaArray:json});
		},
		fail: function () {
            appFunc.checkNetworkStatus();
        }
	}).always(function(){
		hideLoadingMask();
	});
}

function setCategoryMedia(e){
    var el = e.currentTarget || e.target;
    var category = $(el).attr("data-genre");
    var autoPlay = $(el).attr("autoplay") || false;
    if(autoPlay) {
    	// Need this to load the player on click so it can autoplay on mobil
        //doPlayOnMobileHandler({source: window.silent_audio}, false);
    }
	if(!category) return;
	var params = "jetvideos&isJetBox=1&countries=" + (window.countries || '') + "&languages=" + (window.languages || '') + "&type=video&playlistJosn=&subType=playlist&subTypeValue="+category+"&page=" + myApp.videoView;
	var that = this;
	showLoadingMask();
	$.ajax({
		url: ws_end_point + '?' + params + '&t=' + (new Date()).getTime(),
		type: 'GET',
		dataType: 'jsonp',
		error: function(xhr, status, error) {
			console.log("error: setCategoryMedia ............");
            appFunc.checkNetworkStatus();
		},
		success: function(json) {
			var json = eval(json);
			appFunc.loadMediaList({mediaArray:json, autoPlay:autoPlay, showContent: false});
		},
        fail: function () {
            appFunc.checkNetworkStatus();
        }
	}).always(function(){
		hideLoadingMask();
	});
}

function setGenreCategories(genre, callback){
	if(appFunc.checkNetworkStatus() === false) return;

	var category = window.category || "";

	// Important: should not have timestamp to remain contant and always have the same md5 in time
	var params = "jetvideos&isJetBox=1&countries=" + (window.countries || '') + "&languages=" + (window.languages || '') + "&type=playlist&playlistJosn=&subType=playlist&subTypeValue="+genre+"&page=" + myApp.videoView;
	var prefName = genre; //md5(params);

	showLoadingMask();

	appFunc.getPreferenceByName(prefName, function(prefStr) {
        //appFunc.africaVOD_DB.userPreferences.deletePreferenceByName(prefName);

		var callbackDone = false;
		if(prefStr) {
            var prefValueObj = JSON.parse(prefStr);
            callback(prefValueObj);
            callbackDone = true;
            hideLoadingMask();
		}

        $.ajax({
            url: ws_end_point + '?'+params+'&bt=' + (new Date()).getTime(),
            type: 'GET',
            dataType: 'jsonp',
            error: function(xhr, status, error) {
                console.log("error: setGenreCategories ............");
            },
            success: function(json) {
                if(!callbackDone && typeof callback == "function"){
                    callback.call(this, json);
                }

                var prefValueStr = JSON.stringify(json);
                appFunc.savePreferenceByName(prefName, prefValueStr);

                hideLoadingMask();
            },
            fail: function () {}
        }).always(function(){
            hideLoadingMask();
        });
	});
}

function loadCategoryMediaContent(genre){
	
	myApp.isGetMore = true;
	if(rightView.history && rightView.history.length > 1) {
		loadCategoryMedia(genre);
	}else{
		if(myApp.isGetMore !== true) return;
		myApp.isGetMore = false;
		
		rightView.router.loadContent(myApp.categoryContent);
	}
	
	$(".catgoryTitle").html(genre);
	
	myApp.openPanel("right");
}

function ping(callback) {
	var jsonrpcBaseUrl  = "//" + location.hostname + ":12";
	var uri = escape('{"jsonrpc":"2.0"}');
	var url = jsonrpcBaseUrl + '/jsonrpc?request=' + uri;

	showLoadingMask();
	$.ajax({
		type: "get",
		dataType:"jsonp",
		url: url,
		success: function(o) {
			callback(true);
		},
		error:function(e){
			callback(false);
            appFunc.checkNetworkStatus();
		},
		fail: function(e){
			callback(false);
            appFunc.checkNetworkStatus();
		},
		complete: function(e){
			setTimeout(function () {
					//continu checking
					//ping(callback);
			}, 1500);
		}
	}).always(function(){
		hideLoadingMask();
	});
}

function setMediaMetaDataInfo() {
    let skipTime = 10;
	if(!appFunc.isPhonegap()) {
        if (!('mediaSession' in navigator)) return;

        if (!navigator.mediaSession) {
            navigator.mediaSession = {};
        }

        if (!navigator.mediaSession.setActionHandler) {
            navigator.mediaSession.setActionHandler = function () {
            };
        }

        if (!navigator.mediaSession.setActionHandler) {
            navigator.mediaSession.setActionHandler = function () {
            };
        }

        if (!window.MediaMetadata) {
            window.MediaMetadata = function () {
            };
        }

        navigator.mediaSession.setActionHandler('previoustrack', function () {
            appFunc.playPrev();
        });

        navigator.mediaSession.setActionHandler('nexttrack', function () {
            appFunc.playNext();
        });

        navigator.mediaSession.setActionHandler('seekbackward', function () {
            videoPlayer.currentTime(Math.max(videoPlayer.currentTime() - skipTime, 0));
        });

        navigator.mediaSession.setActionHandler('seekforward', function () {
            videoPlayer.currentTime(Math.min(videoPlayer.currentTime() + skipTime, videoPlayer.duration()));
        });

        navigator.mediaSession.setActionHandler('play', function () {
            videoPlayer.play();
        });

        navigator.mediaSession.setActionHandler('pause', function () {
            videoPlayer.pause();
        });
    } else {
        function events(action) {

            const message = JSON.parse(action).message;
            switch(message) {
                case 'music-controls-next':
                    appFunc.playNext();
                    break;
                case 'music-controls-previous':
                    appFunc.playPrev();
                    break;
                case 'music-controls-pause':
                    videoPlayer.pause();
                    break;
                case 'music-controls-play':
                    videoPlayer.play();
                    break;
                case 'music-controls-destroy':
                    location.reload();
                    break;

                // External controls (iOS only)
                case 'music-controls-toggle-play-pause' :
                    // Do something
                    break;
                case 'music-controls-seek-to':
                    const seekToInSeconds = JSON.parse(action).position;
                    MusicControls.updateElapsed({
                        elapsed: seekToInSeconds,
                        isPlaying: true
                    });
                    // Do something
                    break;

                // Headset events (Android only)
                // All media button events are listed below
                case 'music-controls-media-button' :
                    // Do something
                    break;
                case 'music-controls-headset-unplugged':
                    // Do something
                    break;
                case 'music-controls-headset-plugged':
                    // Do something
                    break;
                default:
                    break;
            }
        }

        // Register callback
        MusicControls.subscribe(events);

        // Start listening for events
        // The plugin will run the events function each time an event is fired
        MusicControls.listen();
	}
}

window.doPlayOnMobileHandler = function(media, openModal){
    let poster = media.poster || (media.thumb || '');
    appFunc.updateMiniPlayerBg(poster);

	// Race condition might cause the player not to be initialised on click
	// If that happen, set a delay on starting the music
	if(!window.videoPlayer || !appFunc.eventScope) {
        window.startPlayerTm && clearTimeout(window.startPlayerTm);
        window.startPlayerTm = setTimeout(function() { doPlayOnMobileHandler(media, openModal); }, 500);
        return;
	}

	(function() {
        if (appFunc.canPlayNext === false) return;
        appFunc.canPlayNext = false;
        console.log('again now: ', media);
        window.nowPlayingMedia = media;

        appFunc.homeBtnInitialized = true;

        if (appFunc.isPhonegap()) {
            MusicControls.create({
                track: media.title,		// optional, default : ''
                artist: `${appFunc.bgModeNotificationConfig.title} Music`, // optional, default : ''
                cover: poster,		// optional, default : nothing
                hasClose: true,
            }, function () {
            }, function () {
            });
        } else {
            if (('mediaSession' in navigator)) {
                navigator.mediaSession.metadata = new MediaMetadata({
                    title: media.title,
                    artist: `${appFunc.bgModeNotificationConfig.title} Music`,
                    album: `${appFunc.bgModeNotificationConfig.title} Playlist`,
                    artwork: [{src: poster}]
                });
            }
        }

        let source = media.source;
        if (!appFunc.isMp3(source)) {
            hiApp.showPreloader(`<span class="ytPlayLoader"><a href="javascript:;" class="fa fa-times-circle closeLoadingSpinner"></a></a><span style="color:green; font-weight:bold;">Station Loading...<span>`);
            $.ajax({
                url: ws_end_point,
                data: {action: 'prepareNextSong', uri: media.uri},
                type: 'GET',
                dataType: 'jsonp',
            })
			.then(function (response) {
				if (response.success) {
					media.source = response.file;
					appFunc.canPlayNext = true;
					hiApp.hidePreloader();
					doPlayOnMobileHandler(media, openModal);
				} else {
					hiApp.hidePreloader();
					swal('Oops. Error !');
				}
			});

            return;
        }

        //*
        try {
            var $playerPopup = $('.video-player-popup');

            videoPlayer.poster(poster);

            if (!window.metataInitialized) {
                window.metataInitialized = true;
                setMediaMetaDataInfo(videoPlayer);
            }

            //$playerPopup.removeClass('minimized');

            if (openModal !== false) {
                hiApp.pickerModal($playerPopup[0]);
            }

            appFunc.setBtnCtrlState();

            videoPlayer.ready(function () {
                if (appFunc.currentSrc === source) return;
                appFunc.currentSrc = source;

                showLoadingMask();
                videoPlayer.pause();
                videoPlayer.src(source).play();
                videoPlayer.muted(false);

                console.log('ready...');
            });

            if (appFunc.listenerAdded === true) return;
            appFunc.listenerAdded = true;

            videoPlayer.on('timeupdate', function () {
                var progressBar = document.getElementById('vjsSlider');
                var percentage = Math.floor((100 / videoPlayer.duration()) * videoPlayer.currentTime());
                $(progressBar).width(percentage + '%');
                $('.ui-slider-handle').css('left', `calc(${percentage}% + 7.5px)`);
            });


            videoPlayer.on("canplay", function (elt) {
                appFunc.prepareNextSong();
                appFunc.prepareNextMediaPlaylist();
                hiApp.closeModal("[data-popup='youtube-popup']");
                //appFunc.showHomePage();
                console.log('canplay: ', media);
                hideLoadingMask();
            });

            //enable non-stop
            videoPlayer.on("ended", function () {
                appFunc.canPlayNext = true;
                appFunc.setBtnCtrlState();

                //*
                if (appFunc.isLive()) {
                    appFunc.playLive();
                } else {
                    appFunc.playNext();
                }
                //*/

                hideLoadingMask();
            });

            videoPlayer.on('error', function (e) {
                console.log(source);

                //*
                if (appFunc.isLive()) {
                    appFunc.playLive();
                } else {
                    //appFunc.playNext();
                }
                //*/

                hideLoadingMask();
            });

            videoPlayer.on("pause", function () {
                console.log('paused...');
                appFunc.isPhonegap() && MusicControls.updateIsPlaying(false);
                appFunc.setBtnCtrlState();
            });

            videoPlayer.on("play", function () {
                appFunc.isPhonegap() && MusicControls.updateIsPlaying(true);
                appFunc.setBtnCtrlState();

                videoPlayer.muted(false);
            });

        } catch (e) {
            console.log(e);
        }
    }).call(appFunc.eventScope);
};

module.exports = videoView;